{bibliotheques de procdures pour l'utilisation des cartes
at-ao adresse de base 1c0
et at-mio adresse de base 240
E.Leymarie 12/99}

unit AT_AOMIO;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;


  procedure initchannel(cannal,gain:integer;bipolar:boolean);
  procedure initatmio;
  procedure lecture(moyennage:integer;var resultat:word);
  procedure initatao;
  procedure setvout0(vout:real);
  procedure setvout2(vout:real);
  procedure initdac1;
  procedure setdac1(dbyte:word);
  procedure setvout4(vout:real);
  procedure setvout1(vout:real);
  procedure setvout3(vout:real);
  procedure setvout5(vout:real);
  procedure setvout6(vout:real);



implementation

{*****************************
*
*         partie controle at mio
*
{**************************************}
{initialise la carte at-mio}

procedure initatmio;
begin
{version adresse de base = 240}
   asm
      {initialisation des registres 1  4}
     mov DX,0240h
     mov Ax,$0000
     out DX,Ax

     mov DX,0242H
     mov Ax,$0000
     out DX,Ax

     mov DX,0244H
     mov Ax,$0000
     out DX,Ax

     mov DX,0246H
     mov Ax,$0000
     out DX,Ax

   end;

end;

{********************************}
{initialise le registre configmem,
choix du cannal et du gain choix uni-bipolar}
procedure initchannel(cannal,gain:integer;bipolar:boolean);

var dbyte:word;

begin

{choix de la chaine}
case cannal of
     1:dbyte:=0; {000=0-8 mixert,qo}
     2:dbyte:=64; {040=1-9 mixer}
     3:dbyte:=128; {080=2-10 diodet}
     4:dbyte:=192; {0c0=3-11 diode}
     5:dbyte:=256; {100=4-12 mixert, q1}
     6:dbyte:=320; {140=5-13 mixer}
     7:dbyte:=384; {180=6-14 diodet}
     8:dbyte:=448; {1c0=7-15 diode}
end;

{choix du gain}
case gain of
     1:dbyte:=dbyte+8; {08}
     2:dbyte:=dbyte+16; {10}
     5:dbyte:=dbyte+24; {18}
     10:dbyte:=dbyte+32; {20}
     20:dbyte:=dbyte+40; {28}
     50:dbyte:=dbyte+48; {30}
     100:dbyte:=dbyte+56; {38}
end;

{passage en bipolar mode}
if bipolar then dbyte:=dbyte+$1000;


{configuration de la chaine}

asm
    {initialisation circuit AD}
    mov DX,0259H
    in AL,DX

    {configmenclr}
    mov DX,025bh
    in AL,DX

    {configuration channel}
    mov DX,0248H
    mov Ax,dbyte
    out DX,Ax

    {configmemld}
    mov DX,025bH
    mov AL,$00
    out DX,AL

end


end;


{*************************************}
{lecture du cannal defini par initchannel
avec un moyennage sur moyennage pts}

procedure lecture(moyennage:integer;var resultat:word);

var dbyte:word;
    res,i:integer;

begin
res:=0;
for i:=1 to moyennage do
begin
     asm
     {lancement conversion simple}
       mov DX,025dH
       mov AL,$00
       out DX,AL
     end;

     {test du bit 12 de status register 1}
     repeat
           asm
           mov DX,0258H
           in Ax,DX
           mov dbyte,Ax
           end;
     until ((dbyte and $1000)= $1000);


     asm
     {lecture des donnees}
       mov DX,0240H
       in Ax,DX
       mov dbyte,AX

     end;

res:=dbyte+res;
end;
resultat:=res div moyennage;
end;

{****************************************}
{configuration du dac1 de l'at mio
sert au controle du synth}
procedure initdac1;

begin
     asm

     {configuration du command register 2 pour passer
     en bipolar mode}
     mov DX,0242H
     mov Ax,$0800
     out DX,Ax

     {dac clear register}
     mov DX,025eh
     in AL,DX

     end
end;

{*****************************}
{modifie la tension de sortie du dac1 de
l'at mio (controle synth) puis effectue une pause}
procedure setdac1(dbyte:word);
label
a1;
begin
     asm

     {configuration de dac1}
     mov DX,0252H
     mov Ax,dbyte
     out DX,Ax

     {pause d'environ 2 s}
     push ecx
     mov ecx,$2f
a1:  xor ax,ax
     loop a1
     pop ecx
     end
end;

{*******************************
*
*        partie controle at ao
*
{*******************************************}
{initialise la carte at-ao
adresse de base 1c0}

procedure initatao;

begin

     {configuration de la carte suivant instructions de la
     page 4-39}
     asm
     mov DX,1cah
     mov Ax,$0000
     out DX,Ax

     mov DX,1c9H
     mov AL,$18
     out DX,AL

     mov DX,1c6H
     mov AL,$03
     out DX,AL

     mov DX,1c9H
     mov AL,$58
     out DX,AL

     mov DX,1c2H
     mov Ax,$0000
     out DX,Ax

     mov DX,1c4H
     mov Ax,$0000
     out DX,Ax

     mov DX,1cch
     in AL,DX

     mov DX,1caH
     mov AL,$80
     out DX,AL

     mov DX,1c2H
     mov AL,$00
     out DX,AL

     mov DX,1c4H
     mov Ax,$0000
     out DX,Ax

     mov DX,1c0H
     mov Ax,$0000
     out DX,Ax

     mov DX,1caH
     mov Ax,$0000
     out DX,Ax

     {controle de le methode de updated par cfg2
      et configuration en staight binary mode}

      mov DX,1c2H
      mov Ax,$1f00
      out DX,Ax

     end
end;


{*****************************}
{modifie la tension de sortie du dac0 de
l'at ao puis effectue une pause,
controle la compensation de Q1}

procedure setvout0(vout:real);  {vout est la tension en V}

var dbyte:word;

label a1;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

     asm
     {mise a ff de cfg1 pour autoriser l'acces  dac0}
      mov DX,1caH
      mov Ax,$00ff
      out DX,Ax

      {config de dac0 par transfert d'un mot de 16 bits}
      mov DX,1ccH
      mov Ax,dbyte
      out DX,Ax

      {pause d'environ 2 s}
     push ecx
     mov ecx,$2f
a1:  xor ax,ax
     loop a1
     pop ecx

      end
end;


{**********************}
{modifie la tension de sortie du dac2 de
l'at ao puis effectue une pause
controle la compensation de q0}

procedure setvout2(vout:real);  {vout est la tension en V}

var dbyte:word;

label a1;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

asm
      {config de dac2 par transfert d'un mot de 16 bits}

      mov DX,1d0H
      mov AX,dbyte
      OUT DX,AX

      {pause d'environ 2 s}
     push ecx
     mov ecx,$2f
a1:  xor ax,ax
     loop a1
     pop ecx
end
end;

{***************************
commande la sortie du rack vout4 }
procedure setvout4(vout:real);  {vout est la tension en V}

var dbyte:word;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

asm
      {config de dac4 par transfert d'un mot de 16 bits}

      mov DX,1d4H
      mov AX,dbyte
      OUT DX,AX
end
end;

{***************************
commande la sortie du rack vout1 }
procedure setvout1(vout:real);     {vout est la tension en V}

var dbyte:word;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

asm
      {config de dac1 par transfert d'un mot de 16 bits}

      mov DX,1ceH
      mov AX,dbyte
      OUT DX,AX
end
end;

{***************************
commande la sortie du rack vout3 }
procedure setvout3(vout:real);  {vout est la tension en V}

var dbyte:word;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

asm
      {config de dac3 par transfert d'un mot de 16 bits}

      mov DX,1d2H
      mov AX,dbyte
      OUT DX,AX
end
end;

{***************************
commande la sortie du rack vout5 }
procedure setvout5(vout:real);   {vout est la tension en V}

var dbyte:word;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

asm
      {config de dac5 par transfert d'un mot de 16 bits}

      mov DX,1d6H
      mov AX,dbyte
      OUT DX,AX
end
end;

{***************************
commande le relai rf
vout=3.7 = relai ouvert = nc (acquisition)
vout=0   = relai ferm  = no (saturation)}

procedure setvout6(vout:real);   {vout est la tension en V}

var dbyte:word;

begin

dbyte:=strtoint(floattostr(int(204.8*(vout+10))));

asm
      {config de dac6 par transfert d'un mot de 16 bits}

      mov DX,1d8H
      mov AX,dbyte
      OUT DX,AX
end
end;
{**********************}
end.
