unit CarteMicro;
{ unit d'interface avec la carte d'acquisition Carte Micro }
{ qui est l'quivalent prhistorique de EuroScalaire        }


interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,EuroPSD,GPIB_CEC;

const AdresseCarteMicro=5; { ca ne devrait pas etre la !! }

var PolarisationCourante:string;
    { variable contenant la poalrisation courante }
    { pour eviter les changement intempestifs de polarisation }

Function SendCarteMicro(s:string):string;
procedure suspendrecomptage_CarteMicro;
procedure reprendrecomptage_CarteMicro;
function LancerAcquisition0D_CarteMicro(TT,TU,TD:cardinal;modepolar:string):integer;
procedure litparametres0D_CarteMicro(var NT,NU,ND,MT,MU,MD,TT,TU,TD:cardinal);
function acquisition0Dfinie_CarteMicro:boolean;

{function LancerAcquisition1D_PRISM(TT,TU,TD:real;modepolar:string):integer;
procedure litparametre1D_PRISM(var NT,NU,ND:cardinal; var MT,MU,MD,TT,TU,TD:real);
function LancerAcquisition2D_PRISM(TT,TU,TD:real;modepolar:string):integer;
procedure litparametre2D_PRISM(var NT,NU,ND:cardinal; var MT,MU,MD,TT,TU,TD:real);}


implementation

{ envoie de commandes sur la Carte Micro     }
{ INPUT: la chaine a envoyer                }
{ OUTPUT: le retour de la carte micro        }
Function SendCarteMicro(s:string):string;
var s1:string;
begin
     GpibSend(AdresseCarteMicro,s);
     GpibRead(AdresseCarteMicro,s1,255);
     SendCarteMicro:=s1;
end;

{ arret provisoir du comptage et emission d'un stop }
{ OUTPUT: suspension du comptage par la carte micro }
procedure suspendrecomptage_CarteMicro;
var s1:string;
begin
     s1:=SendCarteMicro('B');
end;

{ reprise du comptage }
{ OUTPUT: reprise du comptage par la carte micro }
procedure reprendrecomptage_CarteMicro;
var s1:string;
begin
     s1:=SendCarteMicro('G');
end;

{*******************************************
lancement d'une acquisition simple
Daf en mode B pour modepolar=UP ou DOWN
            C pour modepolar=UP/DOWN
rq : en mode B TU et TD n'interviennent pas}
{ INPUT: TT, temps total; TU, temps up; TD, temps down }
{        modepolar: le type de polarisation sous la forme d'une chane }
{        UU, UD, DU, DD                                                }
{ OUTPUT: ??                                           }
function LancerAcquisition0D_CarteMicro(TT,TU,TD:cardinal;modepolar:string):integer;
var s1:string;
    t:tdatetime;
begin
    { pilotage des flippers } { ce n'est pas a cette procedure de piloter les flippers }
{    if modepolar='UU' then begin
                      operationform.flipper1_on;
                      operationform.flipper2_off; end;
    if modepolar='DD' then begin
                      operationform.flipper1_off;
                      operationform.flipper2_on;
    if modepolar='UD' then begin
                      operationform.flipper1_on;
                      operationform.flipper2_on; end;
    if modepolar='DU' then begin
                      operationform.flipper1_off;
                      operationform.flipper2_off; end; }
    { petite pause si on a chang l'tat des flippers }
{    if modePolar<>PolarisationCourante
    then begin    t:=time;
                  while time<t+2E-5 do;
                  end;
    PolarisationCourante:=modePolar; }
    { lancement du comptage pour un temps TT }
    s1:='T'+floattostr(TT)+'00';
    if modePolar='UP' then s1:=s1+',+';
    if modePolar='DOWN' then s1:=s1+',-';
    SendCarteMicro(s1);
end;

{ lecture des paramtres sur la carte micro }
{ INPUT:                                    }
{ OUTPUT: nombre de coups/moniteur/temps - total/up/down  }
{ Attention, cette procdure suppose qu'on fait une mesure uniquement dans le canal up-up }
procedure litparametres0D_CarteMicro(var NT,NU,ND,MT,MU,MD,TT,TU,TD:cardinal);
var s:string;
begin
{ lecture des nombres de coups }
s:=SendCarteMicro('+1');NU:=StrToInt(s);
s:=SendCarteMicro('-1');ND:=StrToInt(s);
{lecture des moniteurs }
s:=SendCarteMicro('P');MU:=StrToInt(s);
s:=SendCarteMicro('O');MD:=StrToInt(s);
{lecture du timer }
s:=SendCarteMicro('H');TT:=StrToInt(s);
{writeln(tempsTotal);}
{il n'y a pas de lecture des temps TU et TD}
end;

{ demande si l'acquisition est finie }
{ output true si acquisition finie }
function acquisition0Dfinie_CarteMicro:boolean;
var s:string;
begin
{ l'acquisition est-elle finie ? }
s:=SendCarteMicro('F');
if s<>'00' then
   acquisition0Dfinie_CarteMicro:=true
else
   acquisition0Dfinie_CarteMicro:=false;
end;

end.
