unit ComptagePSDform;
{ procdure d'interface avec le comptage de PRISM }
{ pour les tests avec multidtecteur               }
{ 11.12.01 : FO : mise en place du comptage 1D avec compteur Gabriel }
{ 13.12.01 : FO : bricolage horrible pour faire les comptages doubles sur le multicompteur }
{                 a rendre propre des que possible                                         }
{                 introduction d'une variabe globale ComptageDoubleEnCours                 }
{ ================================================= }
{ A FAIRE }
{ * deactiver save1D ou save2D en fonction du type d'acquisition; PSD 1D ou 2D }
{ * pour le moment on ne peut pas faire d'acquisition double en commptage simple }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, EuroPSD, editdata, carteMicro, graph2D;

type
  TComptagePSD = class(TForm)
    Acquisition: TButton;
    TimerRafraichissementData: TTimer;
    coups: TStringGrid;
    temps: TStringGrid;
    CountingTime: TSpinEdit;
    Label1: TLabel;
    AcqEnCours: TLabel;
    StopButton: TButton;
    Label5: TLabel;
    SpinStates: TComboBox;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    XminBound: TSpinEdit;
    XmaxBound: TSpinEdit;
    YminBound: TSpinEdit;
    YmaxBound: TSpinEdit;
    PreviewButton: TButton;
    GroupBox2: TGroupBox;
    Save1DCheckBox: TCheckBox;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    IndexCrtBox: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    function testacquis:boolean;
    procedure MiseAJourTableau(i:integer;N,M,T:cardinal);
    procedure stop;

    Procedure lancementComptageUnePolarisation(modePolar,Nomspectre:string;p1,p2,p3,p4:extended);
    Procedure lancementComptage(modePolar,NomSpectre:string;p1,p2,p3,p4:extended);
    procedure TimerRafraichissementDataTimer(Sender: TObject);
    procedure AcquisitionClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure InitEuroPSDButtonClick(Sender: TObject);
    procedure PreviewButtonClick(Sender: TObject);
  private
    valeur:array[1..12] of double;   { stockage coups, moniteur, temps }
    { Dclarations prives }
  public
    { Dclarations publiques }
    stopFlag:boolean; { flag indiquant si le comptage doit tre interrompu }
    acquisitionEncours:boolean;
    procedure getComptage(var Nup1,Ndo1,Mup1,Mdo1:cardinal);    
  end;

var
  ComptagePSD: TComptagePSD;
  spectreCrt:string; { spectre dans lequel on veut charger les data }
  sdevant:string;    { chaine sauvegarde dans la boite noire lors d'une acquisition }
  integrale:integer; { nombre de coups dans une zone du compteur definie par les bounds }
  polarisationCourante:string; { polarisation en curs de mesure }
  comptageDoubleEnCours:boolean;
  s,s0:string;
  Nup,Ndo,Mup,Mdo:cardinal; { variables globales qui contiennent les comptages }
                            { ca s'avre necessaire parce que la carte Daffodil perd ces comptages }

implementation

uses Operations, BoiteNoire, MainForm;

{$R *.DFM}

{ simple mise en place des noms sur les colonnes }
procedure TComptagePSD.FormCreate(Sender: TObject);
var
i,j:integer;
begin
coups.cells[0,1]:='N';
coups.cells[0,2]:='M';
coups.cells[0,3]:='T';
temps.cells[0,0]:='Ti';
temps.cells[0,1]:='Cl';
coups.cells[1,0]:='  R++';
coups.cells[2,0]:='  R--';
for i:=1 to 2 do
    for j:=1 to 3 do
        coups.cells[i,j]:='00000000';
for i:=1 to 2 do begin
                 temps.cells[i,0]:='00000020';
                 temps.cells[i,1]:='00001000';
                 end;
top:=500;left:=0;
width:=536;height:=194;
spinStates.itemIndex:=0;
end;

function TComptagePSD.testacquis:boolean;
begin
     if acquisitionEncours=true then result:=true else result:=false;
end;


{ Mise a jour du tableau des data }
{ INPUT: i: typflip, etats de spin }
{        N,M,T: coups, moniteur, temps }
{ OUTPUT: affichage ad-hoc       }
procedure TComptagePSD.MiseAJourTableau(i:integer;N,M,T:cardinal);
var s:string;
    err:integer;
    typflip:integer; { tat de flipping }
begin
typflip:=i;
valeur[1]:=N;
valeur[2]:=M;
valeur[3]:=T;
for i:=1 to 3 do coups.Cells[typflip+1,i]:=formatfloat('00000000',valeur[i]);
{ coups.cells[1,1]:='N';coups.cells[1,2]:='M';coups.cells[1,3]:='T';}
end;


{********************************************}
{ arrt du comptage                          }
procedure TComptagePSD.stop;
var    N,NU,ND,M,MU,MD:cardinal;
       T,TU,TD:cardinal;
begin
     operationform.lireparametres0D(N,NU,ND,M,MU,MD,T,TU,TD); { lecture du nombre de coups, du moniteur et du temsp de comptage }
     MiseAjourTableau(0,N,M,T);
     operationform.suspendrecomptage;
     stopflag:=true;
end;

procedure TComptagePSD.getComptage(var Nup1,Ndo1,Mup1,Mdo1:cardinal);
begin
     Nup1:=Nup;Ndo1:=Ndo;
     Mup1:=Mup;Mdo1:=Mdo;
end;

{ lancement d'un comptage }
{ INPUT: nom du spectre dans lequel on veut stocker les data }
{        p1 indique le nombre de paramtres a sauvegarder apres le symbole 'S' }
{        modePolar : la polarisation lors de l'acquisition                     }
Procedure TComptagePSD.lancementComptageUnePolarisation(modePolar,nomSpectre:string;p1,p2,p3,p4:extended);
var TT,TU,TD:cardinal;
    t:tdatetime;
    i:integer;
    t0,t1:real;
begin
     IndexCrtBox.value:=(GetIndexFichierCrt+1);
     polarisationCourante:=modePolar;
{     if polarisationCourante='UP' then spinStates.itemIndex:=0;
     if polarisationCourante='DOWN' then spinStates.itemIndex:=1; }
     { chaine a sauvegarder dans la boite noire }
     i:=round(p1);
     case i of
          0:sdevant:='Simple '+NomSpectre;
          1:sdevant:='S '+NomSpectre+chr(9)+floattostrf(p2,fffixed,3,7);
          2:sdevant:='S '+NomSpectre+chr(9)+floattostrf(p2,fffixed,3,7)+chr(9)+floattostrf(p3,fffixed,3,7);
          3:sdevant:='S '+NomSpectre+chr(9)+floattostrf(p2,fffixed,3,7)+chr(9)+
          floattostrf(p3,fffixed,3,7)+chr(9)+floattostrf(p4,fffixed,3,7);
     end;
     spectreCrt:=NomSpectre;
     { rglage de la polarisation }
     acqEnCours.caption:='Rglage des flippers';acqEnCours.update;
     if modepolar='UP' then operationform.flipper1_on;
     if modepolar='DOWN' then operationform.flipper1_off;
     { pour le moment on fait la temporisation quel que soit le cas }
     t0:=(time-int(time))*86400;  {temps en s}
     repeat t1:=(time-int(time))*86400;
            if t1<t0 then t1:=t1+86400;  {correction bug passage par minuit}
     until ((t1-t0)>1); { on attend 1 secondes }
{ initialisation de l'EuroPSD }
     acqEnCours.caption:='Initialisation EuroPSD';acqEnCours.update;
     EuroPSDInitsimple(0);  { il y a une temporisation de 3s dans le RAZ }
{ A AMELIORER }
     stopflag:=false;
     acquisitionEncours:=true;acqEnCours.caption:='Acquisition en cours';acqEnCours.update;
     { initialisation des diffrents temps }
{     typpolar:=spinStates.itemindex;  typcompt:=typeOfCounting.itemindex; }
     TT:=CountingTime.value;
{     TU:=strtoint(strgd2.cells[1,0]);
     TD:=strtoint(strgd2.cells[1,0]); }
     if modepolar='UP'  then operationform.LancerAcquisition0D(TT,TU,TD,'UP'); { appel a la procedure de comptage dans EuroPSD }
     if modepolar='DOWN'  then operationform.LancerAcquisition0D(TT,TU,TD,'DOWN'); { appel a la procedure de comptage dans EuroPSD }
     { on lance toujours UU parce que ca permet de stocker les data toujours dans la meme portion de l'EuroPSD }
     TimerRafraichissementData.enabled:=true;
end;

Procedure TComptagePSD.lancementComptage(modePolar,NomSpectre:string;p1,p2,p3,p4:extended);
begin
     if ModePolar='UP' then lancementComptageUnePolarisation('UP','R1Duu',p1,p2,p3,p4);
     if ModePolar='DOWN' then lancementComptageUnePolarisation('DOWN','R1Ddd',p1,p2,p3,p4);
     if ModePolar='UP&DOWN'
     then begin
          comptageDoubleEncours:=true;s0:='';
          lancementComptageUnePolarisation('UP','R1Duu',p1,p2,p3,p4);
          end;
end;
{ mise a jour priodique des valeurs du comptage }
{ et sauvegarde des data lorsque le comptage est termine }
procedure TComptagePSD.TimerRafraichissementDataTimer(Sender: TObject);
var s1:string;
    N,NU,ND,M,MU,MD:cardinal;
    T,TU,TD:cardinal;
    filename:string;
    i:integer;
begin
     { lecture du nombre de coups, du moniteur et du temsp de comptage }
     { pour les deux tats de spin }
     operationform.lireparametres0D(N,NU,ND,M,MU,MD,T,TU,TD); { lecture du nombre de coups, du moniteur et du temsp de comptage }
     { mise a jour de l'affichage 0D }
     if polarisationCourante='UP'  then begin MiseAjourTableau(0,NU,MU,T);Mup:=MU end;
     if polarisationCourante='DOWN'  then begin MiseAjourTableau(1,ND,MD,T);Mdo:=MD end;
{     if operationform.AcquisitionFinie or stopflag then }
     if acquisition0Dfinie_CarteMicro or stopflag then
     begin
        TimerRafraichissementData.enabled:=false;acqEnCours.caption:='PAUSE';acqEnCours.update;
        acquisitionEncours:=false;
        { lecture des data sur le carte EuroPSD }
        { lecture dircete sans passer par l'unit operations }
        if polarisationCourante='UP'
        then litSpectre1D_Gabriel(0,und.indexof('R1Duu'),'polarisation up','UP');
        if polarisationCourante='DOWN'
        then litSpectre1D_Gabriel(0,und.indexof('R1Ddd'),'polarisation down','DOWN');
        { rafraichissement de la fenetre 1D }
        sendmessage(principalform.handle,wm_redessine,0,0);
        { ecriture des conditions dans la boite noire }

        { calcul de l'integrale des coups entre le bornes d'intgration }
        integrale:=0;
        if polarisationCourante='UP'
        then begin
             for i:=xminbound.value to xmaxbound.value
                 do integrale:=integrale+round(und.spect[und.indexOf('R1Duu')].data[i,0,0].z);
             Nup:=integrale;
             end;
        if polarisationCourante='DOWN'
        then begin
             for i:=xminbound.value to xmaxbound.value
                 do integrale:=integrale+round(und.spect[und.indexOf('R1Ddd')].data[i,0,0].z);
             Ndo:=integrale;
             end;
        s:=sdevant+chr(9)+intToStr(integrale)+chr(9);
        {sauvegarde du nombre de coups sur tout le compteur }
        if polarisationCourante='UP'
        then begin str(NU,s1);s:=s+s1+chr(9);str(MU,s1);s:=s+s1+chr(9);str(T,s1);s:=s+s1+chr(9) end;
        if polarisationCourante='DOWN'
        then begin str(ND,s1);s:=s+s1+chr(9);str(MD,s1);s:=s+s1+chr(9);str(T,s1);s:=s+s1+chr(9) end;

        { sauvegarde du spectre de data }
        if Save1DCheckBox.checked=true
        then begin
             IncIndexFichierCrt; {incrementation de l'index fichier}
             if polarisationCourante='UP'
             then begin
                filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+'_'+inttostr(GetIndexFichierCrt)+'.1Du';
                und.spect[und.indexOf('R1Duu')].save(filename);
                s:=s+filename+chr(9);
             end;
             if polarisationCourante='DOWN'
             then begin
                filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+'_'+inttostr(GetIndexFichierCrt)+'.1Dd';
                und.spect[und.indexOf('R1Ddd')].save(filename);
                s:=s+filename+chr(9);
             end
             end;
        { on ne sauvegarde les data dans la boite noire que si on a fini l'tat de spin prcdent }
        { BRICOLAGE INVRAISEMBLABLE !!!!! de moi meme FO}
        if not ComptageDoubleEnCours
        then begin boitnoir.receivetext(s0+s);s0:=''; end
        else begin s0:=s;lancementComptageUnePolarisation('DOWN','R1Ddd',0,0,0,0);comptageDoubleEncours:=false; end;
{ ======================================== }
{ a utiliser avec les microstrips 2D       }
        { procdure dans EuroPSD }
{        litspectre2D_PRISM(1,deuxd.indexof(spectreCrt),und.indexof('VD'),'up','up'); }
        { rafraichissement de la fenetre 2D }
{        sendmessage(principalform.handle,wm_redessine,0,0);
        acquisitionEncours:=false;
        { ecriture des conditions dans la boite noire }
{         s:=sdevant+chr(9)+integrale+chr(9);
         str(N,s1);s:=s+s1+chr(9);str(M,s1);s:=s+s1+chr(9);str(T,s1);s:=s+s1+chr(9);
         boitnoir.receivetext(s);
        { sauveagrde du spectre de data }
{       filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+inttostr(inc.value);
       deuxd.spect[numerospectreU].comment:=deuxd.spect[numerospectreU].comment+' spectre UP';
       deuxd.spect[numerospectreU].savetofile(filename);
       inc.value:=inc.value+1;
        deuxd.spect[indexof("ACUP")].savetofile(filenamebox.text+);
        dataeditform.sauve(2,Filepars[2]);     }
     end;

end;

{ lancement d'une acquistion simple }
procedure TComptagePSD.AcquisitionClick(Sender: TObject);
begin
    if spinstates.text='Simple ++' then lancementComptage('UP','R1Duu',0,0,0,0);  { version pour detecteur 0D, monocompteur }
    if spinstates.text='Simple --' then lancementComptage('DOWN','R1Ddd',0,0,0,0);
    if spinstates.text='Double ++,--' then lancementComptage('UP&DOWN','R1Duu',0,0,0,0);
end;

procedure TComptagePSD.StopButtonClick(Sender: TObject);
begin
     stop;
end;

procedure TComptagePSD.InitEuroPSDButtonClick(Sender: TObject);
begin
     EuroPSDInitsimple(0);
end;


procedure TComptagePSD.PreviewButtonClick(Sender: TObject);
begin
     operationform.suspendrecomptage;
     if spinstates.text='Simple ++'
     then litSpectre1D_Gabriel(0,und.indexof('R1Duu'),'polarisation up','UP');
     if spinstates.text='Simple --'
     then litSpectre1D_Gabriel(0,und.indexof('R1Ddd'),'polarisation down','DOWN');
     operationform.reprendrecomptage;
     sendmessage(principalform.handle,wm_redessine,0,0);
end;

end.
