unit ComptageTests;
{ procdure d'interface avec le comptage de PRISM }
{ pour les tests avec multidtecteur               }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, EuroPSD, editdata, carteMicro, graph2D;

type
  TComptagePSD = class(TForm)
    Acquisition: TButton;
    TimerRafraichissementData: TTimer;
    coups: TStringGrid;
    temps: TStringGrid;
    CountingTime: TSpinEdit;
    Label1: TLabel;
    AcqEnCours: TLabel;
    StopButton: TButton;
    Label5: TLabel;
    SpinStates: TComboBox;
    Panel1: TPanel;
    Save1DCheckBox: TCheckBox;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    function testacquis:boolean;
    procedure MiseAJourTableau(i:integer;N,M,T:cardinal);
    procedure stop;
    Procedure lancementComptage(NomSpectre:string;p1,p2,p3,p4:extended);
    procedure TimerRafraichissementDataTimer(Sender: TObject);
    procedure AcquisitionClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    valeur:array[1..12] of double;   { stockage coups, moniteur, temps }
    { Dclarations prives }
  public
    { Dclarations publiques }
    stopFlag:boolean; { flag indiquant si le comptage doit tre interrompu }
    acquisitionEncours:boolean;
  end;

var
  ComptagePSD: TComptagePSD;
  spectreCrt:string; { spectre dans lequel on veut charger les data }
  sdevant:string;    { chaine sauvegarde dans la boite noire lors d'une acquisition }

implementation

uses Operations, BoiteNoire, PilotageManipMainForm;

{$R *.DFM}

{ simple mise en place des noms sur les colonnes }
procedure TComptagePSD.FormCreate(Sender: TObject);
var
i,j:integer;
begin
coups.cells[0,1]:='N';
coups.cells[0,2]:='M';
coups.cells[0,3]:='T';
temps.cells[0,0]:='Ti';
temps.cells[0,1]:='Cl';
coups.cells[1,0]:='  R++';
coups.cells[2,0]:='  R--';
end;

function TComptagePSD.testacquis:boolean;
begin
if acquisitionEncours=true then result:=true else result:=false;
end;


{ Mise a jour du tableau des data }
{ INPUT: i: typflip, etats de spin }
{        N,M,T: coups, moniteur, temps }
{ OUTPUT: affichage ad-hoc       }
procedure TComptagePSD.MiseAJourTableau(i:integer;N,M,T:cardinal);
var s:string;
    err:integer;
    typflip:integer; { tat de flipping }
begin
typflip:=i;
valeur[1]:=N;
valeur[2]:=M;
valeur[3]:=T;
for i:=1 to 3 do coups.Cells[typflip+1,i]:=formatfloat('00000000',valeur[i]);
{ coups.cells[1,1]:='N';coups.cells[1,2]:='M';coups.cells[1,3]:='T';}
end;


{********************************************}
{ arrt du comptage                          }
procedure TComptagePSD.stop;
var    N,NU,ND,M,MU,MD:cardinal;
       T,TU,TD:cardinal;
begin
     operationform.lireparametres0D(N,NU,ND,M,MU,MD,T,TU,TD); { lecture du nombre de coups, du moniteur et du temsp de comptage }
     MiseAjourTableau(0,N,M,T);
     operationform.suspendrecomptage;
     stopflag:=true;
end;

{ lancement d'un comptage }
{ INPUT: nom du spectre dans lequel on veut stocker les data }
Procedure TComptagePSD.lancementComptage(NomSpectre:string;p1,p2,p3,p4:extended);
var TT,TU,TD:cardinal;
    t:tdatetime;
    i:integer;
begin
     { chaine a sauvegarder dans la boite noire }
     i:=round(p1);
     case i of
          0:sdevant:='Simple '+NomSpectre;
          1:sdevant:='S '+NomSpectre+chr(9)+floattostrf(p2,fffixed,3,7);
          2:sdevant:='S '+NomSpectre+chr(9)+floattostrf(p2,fffixed,3,7)+chr(9)+floattostrf(p3,fffixed,3,7);
          3:sdevant:='S '+NomSpectre+chr(9)+floattostrf(p2,fffixed,3,7)+chr(9)+
          floattostrf(p3,fffixed,3,7)+chr(9)+floattostrf(p4,fffixed,3,7);
     end;
     spectreCrt:=NomSpectre;
     acqEnCours.caption:='Initialisation EuroPSD';acqEnCours.update;
     EuroPSDInitsimple(0);
     t:=time;while (time<t+4E-5) and (time>t) do;
{ on va mettre une petite temporisation pour que la carte ait le temps de se purger }
{ A AM2LIORER }
     stopflag:=false;
     acquisitionEncours:=true;
     acqEnCours.caption:='Acquisition en cours';acqEnCours.update;
     { initialisation des diffrents temps }
{     typpolar:=spinStates.itemindex;
     typcompt:=typeOfCounting.itemindex; }
     TT:=CountingTime.value;
{     TU:=strtoint(strgd2.cells[1,0]);
     TD:=strtoint(strgd2.cells[1,0]); }
     operationform.LancerAcquisition0D(TT,TU,TD,'UU');
     TimerRafraichissementData.enabled:=true;
end;

{ mise a jour priodique des valeurs du comptage }
procedure TComptagePSD.TimerRafraichissementDataTimer(Sender: TObject);
var s,s1:string;
    N,NU,ND,M,MU,MD:cardinal;
    T,TU,TD:cardinal;
    filename:string;
begin
     { lecture du nombre de coups, du moniteur et du temsp de comptage }
     { pour les deux tats de spin }
     operationform.lireparametres0D(N,NU,ND,M,MU,MD,T,TU,TD); { lecture du nombre de coups, du moniteur et du temsp de comptage }
{     if operationform.AcquisitionFinie or stopflag then }
     if acquisition0Dfinie_CarteMicro or stopflag then
     begin
        TimerRafraichissementData.enabled:=false;acqEnCours.caption:='PAUSE';
        litspectre2D_PRISM(1,deuxd.indexof(spectreCrt),und.indexof('VD'),'up','up'); { procdure dans EuroPSD }
        { rafraichissement de la fenetre 2D }
        sendmessage(principalform.handle,wm_redessine,0,0);
        acquisitionEncours:=false;
        { ecriture des conditions dans la boite noire }
         s:=sdevant+chr(9)+integrale+chr(9);
         str(N,s1);s:=s+s1+chr(9);str(M,s1);s:=s+s1+chr(9);str(T,s1);s:=s+s1+chr(9);
         boitnoir.receivetext(s);
        { sauveagrde du spectre de data }
{       filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+inttostr(inc.value);
       deuxd.spect[numerospectreU].comment:=deuxd.spect[numerospectreU].comment+' spectre UP';
       deuxd.spect[numerospectreU].savetofile(filename);
       inc.value:=inc.value+1;


        deuxd.spect[indexof("ACUP")].savetofile(filenamebox.text+);
        dataeditform.sauve(2,Filepars[2]);     }
     end;
     MiseAjourTableau(0,N,M,T);
end;

procedure TComptagePSD.AcquisitionClick(Sender: TObject);
begin
     lancementComptage('VC',0,0,0,0);  { version pour detecteur 0D, monoompteur }
end;

procedure TComptagePSD.StopButtonClick(Sender: TObject);
begin
     stop;
end;

procedure TComptagePSD.Button1Click(Sender: TObject);
begin
     EuroPSDInitSimple(0);
end;

end.
