unit DafMTMX;
{Unit DafMTMX,

Controle la carte DafMTMX du systme daffodile. Sert de maitre a la carte EUROPSD.
                                                                    }
{ E.Leymarie 6/00}
{ MODIFICATIONS }
{ 10/10 modification des commandes d'acquisition 2D pour cable 3 bits}
{20.09.01 : EL : modifications pour utilisation du cable 5 bits :
                 cration de EtatSpin_PAPOL, DafMTMX_modeC, }
interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,EuroPSD, GPIB_CEC;

const AdresseDafMTMX=5;

Function SenddafMTMX(s:string):string;
function moniteur_PAPOL(s:string):real;

procedure suspendrecomptage_PAPOL;
procedure reprendrecomptage_PAPOL;
function EtatSpin_PAPOL:string;
function DafMTMX_modeB(TT:real;polarup:boolean):integer;
function DafMTMX_modeC(TT,TU,TD:real):integer;

function LancerAcquisition2D_PAPOL(decalage:integer;TT,TU,TD:real;modepolar:string):integer;
procedure litparametre2D_PAPOL(var NT,NU,ND:cardinal; var MT,MU,MD,TT,TU,TD:real);

function LancerAcquisition2D_TOF_PAPOL(TT:real;polarup:boolean;retard,largeurcanal:real;nbrframe:integer):integer;
function acquisition2Dfinie_PAPOL:boolean;
procedure litparametre_TOF_PAPOL(polarup:boolean;var ncoups:cardinal; var moniteur,temps:real);

implementation

{*******************************************
}
Function SenddafMTMX(s:string):string;
var s1:string;
begin
     GpibSend(AdresseDafMTMX,s);
     GpibRead(AdresseDafMTMX,s1,255);
     if (s1='?') or (s1='') then MessageDlg('ATTENTION : problme sur DafMTMX ', mtWarning,[mbOk],0);
     SenddafMTMX:=s1;
end;

{*******************************************
retourne la valeur des moniteurs en fonction de s
}
function moniteur_PAPOL(s:string):real;
var s1:string;
begin
if s='UP' then
   begin
   s1:=SenddafMTMX('P');
   moniteur_PAPOL:=strtofloat(s1);
   end;

if s='DOWN' then
   begin
   s1:=SenddafMTMX('O');
   moniteur_PAPOL:=strtofloat(s1);
   end;

if s='TOTAL' then
   begin
   s1:=SenddafMTMX('S');
   moniteur_PAPOL:=strtofloat(s1);
   end;


end;
{*******************************************
arret provisoir du comptage et emission d'un stop}
procedure suspendrecomptage_PAPOL;
var s1:string;
begin
s1:=SenddafMTMX('B');
end;
{*******************************************
reprise du comptage }
procedure reprendrecomptage_PAPOL;
var s1:string;
begin
s1:=SenddafMTMX('G');
end;
{*******************************************
permet de connaitre l'etat de spin en cours de comptage }
function EtatSpin_PAPOL:string;
var s1:string;

begin
s1:=SenddafMTMX('D');
s1:=s1[2];
if (s1='4') or (s1='6') or (s1='C') or (s1='E') then
   result:='DOWN'
else
   if (s1='0') or (s1='2') or (s1='8') or (s1='A') then
      result:='UP'
   else
       result:='nsp';
end;
{*******************************************
lance une acquisition sans initialisation de l'EuroPSD
Daf en mode B pour modepolar=UP ou DOWN
TT en s convertis en nombre entier de 1/100 de s}
function DafMTMX_modeB(TT:real;polarup:boolean):integer;
var s1:string;

begin
TT:=round(TT*100);
{ lancement du comptage sur la EuroScalaire }
s1:='T'+floattostr(TT);
if polarup then
   s1:=s1+',+'
else  s1:=s1+',-';

SenddafMTMX(s1);

end;
{*******************************************
lance une acquisition sans initialisation de l'EuroPSD
Daf en mode C pour modepolar=UP/DOWN
TT,TU et TD en s
convertis en nombre entier de 1/100 de s}
function DafMTMX_modeC(TT,TU,TD:real):integer;
var s1:string;

begin
TT:=round(TT*100);
TU:=round(TU*100);
TD:=round(TD*100);
{Daf MTMX en mode C}
   s1:=SenddafMTMX('%'+floattostr(TU)+','+floattostr(TD)); {rapport de flipping}
   s1:=SenddafMTMX('T+'+floattostr(TT));
end;
{*******************************************
lance une acquisition statique
Daf en mode B pour modepolar=UP ou DOWN  cable 0, 3 ou 4 bits
            C pour modepolar=UP/DOWN     cable 0, 3 bits seulement
rq : en mode B TU et TD n'interviennent pas}
function LancerAcquisition2D_PAPOL(decalage:integer;TT,TU,TD:real;modepolar:string):integer;
var s1:string;
    TUs,TDs:string;

begin
EuroPSDInitsimple(decalage);
TUs:=floattostr(round(TU*100));
TDs:=floattostr(round(TD*100));

if (modepolar='UP/DOWN') and ((decalage=0) or (decalage=3) or (decalage=5)) then
   begin
   {Daf MTMX en mode C}
   s1:=SenddafMTMX('%'+TUs+','+TDs); {rapport de flipping}
   s1:=SenddafMTMX('T-'+floattostr(TT)+'00');
   end
else
    begin
    {Daf MTMX en mode B}
    s1:='T'+floattostr(TT)+'00';
    if modepolar='UP' then
    s1:=s1+',+'
    else  s1:=s1+',-';

    SenddafMTMX(s1);
    end;
end;

{******************************************
}
procedure litparametre2D_PAPOL(var NT,NU,ND:cardinal; var MT,MU,MD,TT,TU,TD:real);
var s:string;
begin
{ lecture des nombres de coups }
s:=SenddafMTMX('+1');
NU:=StrToInt(s);
s:=SenddafMTMX('-1');
ND:=StrToInt(s);
NT:=NU+ND;    {il n'y a pas de lecture du nombre total de coups}

{lecture des moniteurs }
MT:=moniteur_PAPOL('TOTAL');
MU:=moniteur_PAPOL('UP');
MD:=moniteur_PAPOL('DOWN');

{lecture du timer }
s:=SenddafMTMX('H');
TT:=StrTofloat(s)/100;
{il n'y a pas de lecture des temps TU et TD}

end;

{*******************************************
lance une acquisition TOF (cable 3 ou 4 bits)
Daff en mode B = choix de polar sans flip
Input TT: temps total en s
      polarup : true si polar UP
      retard en s
      largeur canal en ms
      }

function LancerAcquisition2D_TOF_PAPOL(TT:real;polarup:boolean;retard,largeurcanal:real;nbrframe:integer):integer;

var s1:string;

begin

EuroPSDInitTOF(retard,largeurcanal,nbrframe);{initialise l'europsd en acquisition TOF }
{ lancement du comptage sur la EuroScalaire }
s1:='T'+floattostr(TT)+'00';
if polarup then
   s1:=s1+',+'
else  s1:=s1+',-';

SenddafMTMX(s1);

end;
{*******************************************
output true si acquisition finie}
function acquisition2Dfinie_PAPOL:boolean;

var s:string;
begin
{ l'acquisition est-elle finie ? }
s:=SenddafMTMX('F');
if s<>'00' then
   acquisition2Dfinie_PAPOL:=true
else
    acquisition2Dfinie_PAPOL:=false;

end;

{*******************************************
lit le nombre de coups, le moniteur, le timer
dans le mode B de la Daff
INPUT polarup;true si up
OUPUT ncoups :cardinal
      moniteur real
      temps en s
}


procedure litparametre_TOF_PAPOL(polarup:boolean;var ncoups:cardinal; var moniteur,temps:real);
var s:string;
begin
{ lecture du nombre de coups }
if polarup then
   s:=SenddafMTMX('+1')
else s:=SenddafMTMX('-1');
if s<>'' then
   ncoups:=StrToInt(s);

{lecture du moniteur }
if polarup then
   s:=SenddafMTMX('P')
else s:=SenddafMTMX('O');
if s<>'' then
   moniteur:=StrTofloat(s);

{lecture du timer }
s:=SenddafMTMX('H');
if s<>'' then
   temps:=StrTofloat(s)/100;

end;

end.
