unit EuroScaler;
{ unit d'interface avec la carte d'acquisition Carte Micro }
{ qui est l'quivalent prhistorique de EuroScalaire        }


interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,EuroPSD,GPIB_CEC;

const AdresseEuroScaler=5; { ca ne devrait pas etre la !! }

var PolarisationCourante:string;
    { variable contenant la polarisation courante }
    { pour eviter les changement intempestifs de polarisation }

Function  SendEuroScaler(s:string):string;
procedure suspendrecomptage_EuroScaler;
procedure reprendrecomptage_EuroScaler;
function  LancerAcquisition0D_EuroScaler(TT,TU,TD:cardinal;modepolar:string):integer;
procedure litparametres0D_EuroScaler(var NbrCoups,Moniteur,TempsTotal:cardinal);
function  acquisition0Dfinie_EuroScaler:boolean;

{function LancerAcquisition1D_PRISM(TT,TU,TD:real;modepolar:string):integer;
procedure litparametre1D_PRISM(var NT,NU,ND:cardinal; var MT,MU,MD,TT,TU,TD:real);
function LancerAcquisition2D_PRISM(TT,TU,TD:real;modepolar:string):integer;
procedure litparametre2D_PRISM(var NT,NU,ND:cardinal; var MT,MU,MD,TT,TU,TD:real);}


implementation

{ envoie de commandes sur la Carte Micro     }
{ INPUT: la chaine a envoyer                 }
{ OUTPUT: le retour de la carte micro        }
Function SendEuroScaler(s:string):string;
var s1:string;
begin
     GpibSend(AdresseEuroScaler,s);
     GpibRead(AdresseEuroScaler,s1,255);
     SendEuroScaler:=s1;
end;

{ initialisation de l'EuroPSD                       }
{ OUTPUT: suspension du comptage par la carte micro }
{ A COMPLETER }
procedure initialisation_EuroScaler;
var s1:string;
begin
     { selection du format : format ascii }
     s1:=SendEuroScaler('I=,1');
     { desactivation des quatres phases et initialisation de leur paramtres }
     { temps de comptage de 20s, pas de temporisation                        }
     { dfinition des sorties S1 et S2                                       }
     sendEuroscaler('I=1');sendEuroScaler('>1,00,2,200,3,0,4,00');
     sendEuroscaler('I=2');sendEuroScaler('>1,00,2,200,3,0,4,01');
     sendEuroscaler('I=3');sendEuroScaler('>1,00,2,200,3,0,4,02');
     sendEuroscaler('I=4');sendEuroScaler('>1,00,2,200,3,0,4,03');
     { initialisation des differents sets en mode flipping }
end;

{ arret provisoire du comptage et emission d'un stop }
{ OUTPUT: suspension du comptage par la carte micro }
{ ok pour ES }
procedure suspendrecomptage_EuroScaler;
var s1:string;
begin
     s1:=SendEuroScaler('B');
end;

{ reprise du comptage }
{ OUTPUT: reprise du comptage par la carte micro }
{ ok pour ES }
procedure reprendrecomptage_EuroScaler;
var s1:string;
begin
     s1:=SendEuroScaler('G');
end;

{ activation de la phase n             }
{ et desactivation des autres phases   }
{ INPUT: n, numero de la pahse a activer }
{        duree,  durre de la mesure      }
procedure activatePhase(n,duree:string);
begin
     if n='1' then begin
     sendEuroscaler('I=1');sendEuroScaler('>1,01,2,'+duree);
     sendEuroscaler('I=2');sendEuroScaler('>1,00');
     sendEuroscaler('I=3');sendEuroScaler('>1,00');
     sendEuroscaler('I=4');sendEuroScaler('>1,00'); end;
     if n='2' then begin
     sendEuroscaler('I=1');sendEuroScaler('>1,00');
     sendEuroscaler('I=2');sendEuroScaler('>1,01,2,'+duree);
     sendEuroscaler('I=3');sendEuroScaler('>1,00');
     sendEuroscaler('I=4');sendEuroScaler('>1,00'); end;
     if n='3' then begin
     sendEuroscaler('I=1');sendEuroScaler('>1,00');
     sendEuroscaler('I=2');sendEuroScaler('>1,00');
     sendEuroscaler('I=3');sendEuroScaler('>1,01,2,'+duree);
     sendEuroscaler('I=4');sendEuroScaler('>1,00'); end;
     if n='4' then begin
     sendEuroscaler('I=1');sendEuroScaler('>1,00');
     sendEuroscaler('I=2');sendEuroScaler('>1,00');
     sendEuroscaler('I=3');sendEuroScaler('>1,00');
     sendEuroscaler('I=4');sendEuroScaler('>1,01,2,'+duree); end;
end;

{*******************************************
lancement d'une acquisition simple
Daf en mode B pour modepolar=UP ou DOWN
            C pour modepolar=UP/DOWN
rq : en mode B TU et TD n'interviennent pas}
{ INPUT: TT, temps total en secondes; TU, temps up; TD, temps down }
{        modepolar: le type de polarisation sous la forme d'une chane }
{        on met les bits S1 et S2 aux positions pertinentes            }
{        UU, UD, DU, DD                                                }
{ OUTPUT: ??                                           }
function LancerAcquisition0D_EuroScaler(TT:cardinal;modepolar:string):integer;
var s1:string;
    t:tdatetime;
    duree:string;
begin
    duree:=floatToString(TT);
    { mise en place des bits pertinents S1 et S1 pour piloter l'EuroScaler }
    { activation de la phase pertinente                                    }
    { et dsactivation des autres phases                                   }
    if modePolar = 'UU' then begin activatePhase('1',duree); end;
    if modePolar = 'DD' then begin activatePhase('2',duree); end;
    if modePolar = 'UD' then begin activatePhase('3',duree); end;
    if modePolar = 'DU' then begin activatePhase('4',duree); end;
    { lancement du comptage pour un temps TT }
    { T+ pour un comptage en mode flipping   }
    s1:='T+'+duree+'00';
    SendEuroScaler(s1);
end;

{ lecture des paramtres sur la carte Euroscaler }
{ INPUT:                                    }
{ OUTPUT: nbrCoups, Moniteur, TempsTotal    }
{ Attention, cette procdure suppose qu'on fait une mesure uniquement dans le canal up-up }
procedure litparametres0D_EuroScaler(modePolar:string;var NbrCoups,Moniteur,TempsTotal:cardinal);
var s1,s2,s3:string;
begin
   { lecture des nombres de coups }
   { selection du bon set de flipping }
   { lecture du timer et du moniteur de phase }
   if modePolar = 'UU' then sendEuroscaler('I=1');s1:=sendEuroScaler('X1');
   if modePolar = 'DD' then sendEuroscaler('I=2');s1:=sendEuroScaler('X2');
   if modePolar = 'UD' then sendEuroscaler('I=3');s1:=sendEuroScaler('X3');
   if modePolar = 'DU' then sendEuroscaler('I=4');s1:=sendEuroScaler('X4');
   { extraction de la chaine temps et de la chaine moniteur  partir de s1 }
   s2=copy(s1,10,8);s1=copy(s1,1,8);
   TempsTotal:=StrToInt(s1);
   Moniteur:=StrToInt(s2);
   { lecture du nombre de coups dans le bon registre }
   s3:=SendEuroScaler('E1');
   NbrCoups:=StrToInt(s3);
end;

{ demande si l'acquisition est finie }
{ output true si acquisition finie }
{ ok pour l'EuroPSD }
function acquisition0Dfinie_EuroScaler:boolean;
var s:string;
begin
{ l'acquisition est-elle finie ? }
s:=SendEuroScaler('F');
if s<>'00' then
   acquisition0Dfinie_EuroScaler:=true
else
   acquisition0Dfinie_EuroScaler:=false;
end;

end.
