unit PilotageRMN;
{unit de prise du signal RMN et de son traitement pour combinaison avec le programme de pilotage PAPOL
fonctions hauts niveaux dans la gestion des cartes AT
traitement du signal et calcul de la polarisation
E.Leymarie 10/00
MODIFICATIONS :
17/11/00 : (edouard)
         Ajout d'une procdure RMNacqui.mesurepolar(n:integer;var polar,temps:real) pour liaison avec la fonction RMNlitpolar de l'interpreteur.
         Cration de la fonction RMNacqui.TestAcquis:boolean; pour tester la fin de l'acquisition RMN.  }
{27.03.01 : EL : modifications pour jumelage avec traitement:
                 modification spectre.addspectre(X,Y) en spectre.addspectre(X,Y,1)
                 modification data[x,y] en data[x,y,0]}
{28.11.01 : EL : Suppression de la translation de la base...
                 Ajout d'une possibilite de Fit par un polynome du signal de base avec MTxVec   }
{29.11.01 : EL : debut du jumelage avec l'unit RMNbase,
                 L'unit complete s'appelle maintenant Pilotage RMN                              }


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls,editdata,AT_AOMIO,GPIB_CEC,MainForm,
  EditReal,MtxVec,polynoms, ComCtrls;
type
    brut512=array[1..512] of longint;
const
      wm_redessine=$403+wm_user;
      chaine=3; {qmetre 0, diode}
      gain=1;
      adressesynthe=10; {adresse GPIB du synthe}
      dbytemin=-4730; {determine la valeur min de l'escalier de commande du synth
                     ici -1.5V}
      inc=37;{determine la hauteur des marches de tension}
type
  TPilotageRMNForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox4: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label22: TLabel;
    moy: TSpinEdit;
    npassage: TSpinEdit;
    Mode: TComboBox;
    repet: TSpinEdit;
    base: TCheckBox;
    calpol: TCheckBox;
    affichespe: TCheckBox;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Timeracqui: TTimer;
    GroupBox5: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    choixspectrebase: TComboBox;
    choixspectresig: TComboBox;
    GroupBox7: TGroupBox;
    Label5: TLabel;
    Label25: TLabel;
    sigPol: TComboBox;
    basepol: TComboBox;
    spectrepol: TComboBox;
    sousbase: TCheckBox;
    GroupBox2: TGroupBox;
    Fiter: TCheckBox;
    Fitdeg: TSpinEdit;
    AffFit: TCheckBox;
    FitBasMax: TEditReal;
    FitHauMax: TEditReal;
    FitHauMin: TEditReal;
    FitBasMin: TEditReal;
    Label19: TLabel;
    Label18: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    calculpol: TButton;
    Nbrspectres: TSpinEdit;
    Label6: TLabel;
    run: TButton;
    stop: TButton;
    scansynthe: TButton;
    CheckBox2: TCheckBox;
    Label9: TLabel;
    duree: TEditReal;
    freqmod: TEditReal;
    PolMain: TEditReal;
    PolOptions: TEditReal;
    AcquiStatus: TLabel;
    LoadConfig: TButton;
    SaveConfig: TButton;
    OpenconfigDia: TOpenDialog;
    SaveConfigDia: TSaveDialog;
    group: TGroupBox;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label15: TLabel;
    ent: TComboBox;
    onsynthe: TButton;
    offsynthe: TButton;
    StatusSynthe: TLabel;
    GroupBox1: TGroupBox;
    Vout1set: TButton;
    Vout3set: TButton;
    Vout5set: TButton;
    Vout4set: TButton;
    GroupBox6: TGroupBox;
    Label14: TLabel;
    Label23: TLabel;
    PauseSweep: TEdit;
    PauseSweepfin: TEdit;
    bsig: TButton;
    bbase: TButton;
    StatusField: TLabel;
    Vout1ud: TUpDown;
    Vout1: TEditReal;
    Vout4ud: TUpDown;
    vout3ud: TUpDown;
    vout5ud: TUpDown;
    Vout4: TEditReal;
    vout3: TEditReal;
    vout5: TEditReal;
    freqAcq: TEditReal;
    ampacq: TEditReal;
    NivAcq: TEditReal;
    freqg: TEditReal;
    freqd: TEditReal;
    function sendSynthe(s:string):string;
    procedure choixspectredropdown(Sender: TObject);
    procedure pause(temps:real);
    procedure ModeChange(Sender: TObject);
    procedure calculfiche(Sender: TObject);

    procedure initacquisition(freq,amp,niv:real);
    procedure acqui_brut(moyennage:integer;var result:brut512;var t:real);
    procedure acqui_spectre(npass,moyennage,indsig,indbase:integer;base:boolean;var temps:real);

    function  initundRMN(nom:string;freq,amp:real):integer;
    procedure bruttospectre1D(result:brut512;ind:integer);

    procedure  simple(npass,moyennage:integer;nomsig,nombase:string;base:boolean;var temps,polar:real);
    procedure acquitemps(sender:Tobject);

    procedure formate(indsig,indbase,indresult:integer);
    function calcul_aire(ind:integer;freqgauche,freqdroite:real):real;
    procedure traitespectre(nomsig,nombase,nomresult:string; var polar:real);

    procedure scansyntheClick(Sender: TObject);
    procedure stopClick(Sender: TObject);
    procedure onsyntheClick(Sender: TObject);
    procedure offsyntheClick(Sender: TObject);
    procedure initsynthe(freq,amp,niv:real);

    procedure runClick(Sender: TObject);
    procedure calculpolClick(Sender: TObject);
    procedure mesurepolar(n:integer;var polar,temps:real);
    Function  TestAcquis:boolean;
    procedure SaveConfigClick(Sender: TObject);
    procedure LoadConfigClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    function  CreatespectreRMN(nom:string):integer;
    procedure SweepB(com:string);
    procedure setVout(sender:Tobject);
    procedure syntheon;
    procedure syntheoff;
    procedure freqAcqChange(Sender: TObject);
    procedure VoutudClick(Sender: TObject; Button: TUDBtnType);
    procedure Changefieldclick(Sender: TObject);

  private
    { Dclarations prives}
    resultbrut:brut512; {stocke les data brutes}
    stopflag,acquisitionRunning:boolean;
    compteur:integer; {donne le nbre de spectres acquis en mode f(t)}
  public
    { Dclarations publiques}
  end;



var
  PilotageRMNForm: TPilotageRMNForm;

implementation

uses  Graph1D, visu_polarisation, comptage2DTOF, BoiteNoire;

{$R *.DFM}
{*******************************************

***                                         procedures gnrales  Gestion Fiche

{*******************************************                         }
function TPilotageRMNForm.sendSynthe(s:string):string;
var temp:string;
begin
gpibsend(adressesynthe,s);
gpibread(adressesynthe,temp,255);
result:=temp;
end;
{*******************************************                         }
procedure TPilotageRMNForm.FormCreate(Sender: TObject);
var ind,i:integer;
begin
CreatespectreRMN('Signal1');
CreatespectreRMN('Signal1t');
CreatespectreRMN('Signal2');
CreatespectreRMN('Signal2t');
CreatespectreRMN('base');

initatao;
initatmio;
initdac1;
{Mise du champ en signal}
SweepB('signal');
end;
{commande une pause de temps msec}
procedure TPilotageRMNForm.pause(temps:real);

var t0,t:real;

begin
t0:=(time-int(time))*86400;  {temps en s}
repeat
      t:=(time-int(time))*86400;
until ((t-t0)*1000>temps)
end;

procedure TPilotageRMNForm.choixspectredropdown(Sender: TObject);
var i:integer;
begin
{reinitialisation des items des choixspectres a chaque ouverture du combo}
choixspectresig.items.clear;
choixspectrebase.items.clear;
sigpol.items.clear;
basepol.items.clear;
spectrepol.items.clear;

for i:=1 to totalspectre do
if und.spect[i]<>nil then
   begin
   choixspectresig.items.add(und.spect[i].nom);
   choixspectrebase.items.add(und.spect[i].nom);
   sigpol.items.add(und.spect[i].nom);
   basepol.items.add(und.spect[i].nom);
   spectrepol.items.add(und.spect[i].nom);
   end;
end;
{*************************
}
procedure TPilotageRMNForm.ModeChange(Sender: TObject);
begin
if mode.text='Simple' then
   begin
   label4.visible:=false;
   repet.visible:=false;
   label6.visible:=false;
   nbrspectres.visible:=false;
   end
else
   begin
   label4.visible:=true;
   repet.visible:=true;
   label6.visible:=true;
   nbrspectres.visible:=true;
   end;
end;
{********************************************
calcul le temps necessaire  la mesure et la frequence du signal de balayage}
procedure TPilotageRMNForm.calculfiche(Sender: TObject);
var T:real;
begin
t:=6.33*moy.value+1.2;
duree.text:=floattostr(npassage.value*t/1000);
freqmod.text:=floattostr(1000/t);
end;

{********************************************

****                                            procedures acquisition bas niveau

**********************************************}

{*********************************
initialise les cartes d'acquisitions et le synthe pour une acquisition}
procedure TPilotageRMNForm.initacquisition(freq,amp,niv:real);
begin
stopflag:=false;
initchannel(chaine,gain,false);
if statusSynthe.caption<>'initialis' then initsynthe(freq,amp,niv);
{syntheon;}

end;
{**************************
 ralise un passage avec le moyennage spcifi et donne le temps de
fin de comptage
INPUT moyennage: nombre d'acquisition par pas de frequence
OUPUT result: tableau 512*integer= donnes brutes
      t:temps en s }
procedure tPilotageRMNForm.acqui_brut(moyennage:integer;
          var result:brut512;var t:real);

var  j:integer;
     dbyte:smallint;
     resultat:word;

begin

dbyte:=dbytemin;

for j:=1 to 256 do
         begin
           setdac1(dbyte);
           lecture(moyennage,resultat);
           dbyte:=dbyte+inc;
           result[j]:=resultat;
         end;

for j:=257 to 512 do
         begin
           dbyte:=dbyte-inc;
           setdac1(dbyte);
           lecture(moyennage,resultat);
           result[j]:=resultat;
         end;

t:=(time-int(time))*86400;  {temps en s}
end;
{***********************************************
realise un ensemble de npass passages avec au besoin la prise du spectre de base,
fait la conversion en mv et charge les spectres und
INPUT npass: nombre de passage a realiser
      moyennage : nombre d'acquisition par pas de frequence
      indsig,indbase : index des spectres recepteurs
      base : true si acquisition du signal de base}
procedure tPilotageRMNForm.acqui_spectre(npass,moyennage,indsig,indbase:integer;base:boolean;var temps:real);
var  i:integer;
begin

{prise du signal}
AcquiStatus.caption:='Acquisition Signal';
i:=1;
while (i<=npass) and (stopflag=false) do
      begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
      und.spect[indsig].data[0,0,0].mon:=und.spect[indsig].data[0,0,0].mon+1;
      bruttospectre1D(resultbrut,indsig);
      i:=i+1;
      end;

{au besoin:prise du signal de base dans les meme conditions}
if base then
begin
AcquiStatus.caption:='Acquisition Base';
sweepB('base');
{prise du signal de base}
i:=1;
while (i<=npass) and (stopflag=false) do
      begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
      und.spect[indbase].data[0,0,0].mon:=und.spect[indbase].data[0,0,0].mon+1;
      bruttospectre1D(resultbrut,indbase);
      i:=i+1;
      end;
sweepB('signal');

end;
AcquiStatus.caption:='Pause Timer';
end;
{********************************************
*
*                                            procedures acquisition haut niveau
*
**********************************************}

{************************************
acquisition simple = un acqui_spectre
INPUT npass:nombre total de passage pour le spectre
      moyennage: moyennage de l'acquisition
      nomsig,nombase: nom des spectres recepteurs
      base: true si on veut faire l'acquisition du signal de base dans les meme conditions
OUTPUT temps: donne le temps de fin
       polar : donne la polar }
procedure  tPilotageRMNForm.simple(npass,moyennage:integer;nomsig,nombase:string;base:boolean;var temps,polar:real);
var indsig,indbase:integer;

begin

{initialisation des spectres}
indsig:=initundRMN(nomsig,freqacq.value,ampacq.value);
und.spect[indsig].comment:=datetostr(date)+' '+timetostr(time)+' '+'signal brut';
if base then
   begin
   indbase:=initundRMN(nombase,freqacq.value,ampacq.value);
   und.spect[indbase].comment:=datetostr(date)+' '+timetostr(time)+' '+'signal base';
   end;
{acquisition}
acqui_spectre(npass,moyennage,indsig,indbase,base,temps);
{traitement}
if calpol.checked then
      traitespectre(nomsig,nombase,spectrepol.text,polar);
{affichage}
if affichespe.checked then
      sendmessage(principalform.handle,wm_redessine,0,0);
{enregistrement}

end;
{************************************
acquisition f(t)
lance des simples rythms par le timer. l'ensemble des choix sont rinitialis  chaque fois}
procedure tPilotageRMNForm.acquitemps(sender:Tobject);
var npass,moyennage:integer;
    nomsig,nombase:string;
    temps,polar:real;

begin
timeracqui.enabled:=false;
timeracqui.interval:=repet.value;

if (comptage2DTOFform.status.caption='Acquisition') or (comptage2DTOFform.status.caption='Pause') or (not comptage2DTOFform.TestAcquis) then
begin  {IF destine a laisser la main au systeme neutron}
  compteur:=compteur+1;
  npass:=npassage.value;
  moyennage:=moy.value;
  nomsig:=choixspectresig.text;
  nombase:=choixspectrebase.text;
  {acquisition}
  simple(npass,moyennage,nomsig,nombase,base.checked,temps,polar);
  {affichage de la polar}
  if calpol.checked then
    visupol.ajoute(temps,polar);
end;

{gestion fin d'acquisition}
if ((compteur<Nbrspectres.value) or (Nbrspectres.value=0)) And not stopflag then
   timeracqui.enabled:=true
else
   begin
   Scansynthe.enabled:=true;
   AcquiStatus.caption:='Attente';
   end;

end;
{*************************************
stop tous les process}
procedure TPilotageRMNForm.stopClick(Sender: TObject);
begin
stopflag:=true;
end;
{*****************************
*
*                                            partie transformation de rsultat
*
{*************************}

{*************************
verifie l'existance d'un spectre 1 D et l'initialise  pour une acquisition RMN
entre les frquences en fonction de freq et amp
INPUT nom:nom du spectre und
      freq:frequence centrale en MHz
      amp:amplitude de modulation en kHz}

function  tPilotageRMNForm.initundRMN(nom:string;freq,amp:real):integer;
var ind,i:integer;
    deltaf:real;
begin
ind:=und.indexof(nom);
deltaf:=amp*1.02/1000; {conversion en MHz et correction de l'amplitude reel de balayage 2%}
{creation au besoin}
if ind=-1 then
   ind:=CreatespectreRMN(nom);

{initialisation}

und.spect[ind].data[0,0,0].mon:=0;    {designe le nbre de passages}
for i:=0 to 255 do
    und.spect[ind].data[i,0,0].x:=(freq-deltaf)+2*deltaf*i/255;
initundRMN:=ind;
end;
{********************************
(Utilis pendant l'acquisition du signal)
effectue la conversion en mV, la superposition des parties montante et descendante,
et l'accumulation d'un signal brute dans un
spectre 1 D en fonction du nombre .mon de signal brute deja acquis}

procedure tPilotageRMNForm.bruttospectre1D(result:brut512;ind:integer);

var i:integer;
    tampon,n:real;

begin
n:=und.spect[ind].data[0,0,0].mon; {nombre de spectres deja acquis}
for i:=0 to 255 do
    begin
    tampon:=(result[i+1]/(6.5536*gain)+result[512-i]/(6.5536*gain))/2; {conversion en mV et superposition}
    und.spect[ind].data[i,0,0].z:=(und.spect[ind].data[i,0,0].z*(n-1)+tampon)/n; {accumulation}
    end;
end;

{**************************
(Utilis pendant le traitement du signal)
initialise les frequences de nomresult comme nomsig
Ralise ou la soustraction NomResult=NomSig-nombase  ou  NomResult=NomSig suivant le choix sousbase
Puis Fit NomResult par un polynome et effectue la soustraction du fit suivant le choix Fiter }
procedure tPilotageRMNForm.formate(indsig,indbase,indresult:integer);

var i,indfit,taille:integer;
    Xval,Yval,Coef:Tvec;


begin

{initialisation abscisse}
for i:=0 to 255 do
    und.spect[indresult].data[i,0,0].x:=und.spect[indsig].data[i,0,0].x;

{soustraction du signal de base}
if sousbase.checked then
for i:=0 to 255 do
    und.spect[indresult].data[i,0,0].z:=und.spect[indsig].data[i,0,0].z-und.spect[indbase].data[i,0,0].z
else
for i:=0 to 255 do
    und.spect[indresult].data[i,0,0].z:=und.spect[indsig].data[i,0,0].z;

{***  Fit }
if fiter.Checked then
begin
   if affFit.Checked then
   begin  {le Fit va etre stock dans le spectre Fit}
   indfit:=CreatespectreRMN('Fit');
   {initialisation abscisse}
   for i:=0 to 255 do
      und.spect[indfit].data[i,0,0].x:=und.spect[indsig].data[i,0,0].x;
   end;
   {cration des Vecteurs TVec}
   CreateIt(Xval,Yval,Coef);
   Xval.Size(256,false);
   Yval.Size(256,false);
   Coef.Size(Fitdeg.value+1,false);
   {initialisation des vecteurs}
   taille:=0;
   for i:=0 to 255 do
    if  ((FitBasMin.Value<und.spect[indresult].data[i,0,0].x) and (und.spect[indresult].data[i,0,0].x<FitBasMax.Value)) or
        ((FitHauMin.Value<und.spect[indresult].data[i,0,0].x) and (und.spect[indresult].data[i,0,0].x<FitHauMax.Value)) then
        begin
         Xval.values[taille]:=und.spect[indresult].data[i,0,0].x;
         yVal.values[taille]:=und.spect[indresult].data[i,0,0].z;
         taille:=taille+1;
        end;

   Xval.Size(taille,false);
   Yval.Size(taille,false);
   {Fit}
   polyfit(Xval,Yval,Fitdeg.value,coef);
   {initialisation du spectre Fit}
   if affFit.Checked then
     for i:=0 to 255 do
       und.spect[indfit].data[i,0,0].Z:=polyeval(und.spect[indfit].data[i,0,0].x,coef);
   {soustraction par le fit}
   if  affFit.Checked then
     for i:=0 to 255 do
        und.spect[indresult].data[i,0,0].z:=und.spect[indresult].data[i,0,0].z-und.spect[indfit].data[i,0,0].z
   else
     for i:=0 to 255 do
        und.spect[indresult].data[i,0,0].z:=und.spect[indresult].data[i,0,0].z-polyeval(und.spect[indresult].data[i,0,0].x,coef);
   {libration Tvec}
   FreeIt(Xval,Yval,Coef);
end; {fin du fit}


end;
{***********************
calcul l'aire d'un spectre en fonction des bornes choisies
Si l'option Fit n'est pas choisie, la fonction calcul la moyenne de la ligne de base a gauche et a droite du pic (correction ordre 0)
Si l'option Fit est choisie, la fonction calcul directement l'aire entre les borne avec une moyenne de la ligne de base Nullu       }
function tPilotageRMNForm.calcul_aire(ind:integer;freqgauche,freqdroite:real):real;

var i,n:integer;
    tampon,resultat,ldb:real;


begin

tampon:=0;n:=0;
resultat:=0;
if Not Fiter.checked then
  begin {calcul de la moyenne de la base  gauche et a droite du spectre}
  for i:=0 to 255 do
    if (und.spect[ind].data[i,0,0].x<freqgauche) or (und.spect[ind].data[i,0,0].x>freqdroite) then
       begin
       tampon:=tampon+und.spect[ind].data[i,0,0].z;
       n:=n+1;
       end;

  ldb:=tampon/n;
  end
else
  ldb:=0;

{calcul par les trapezes de l'air entre le signal et la moyenne calcule}

for i:=0 to 255 do
    if (und.spect[ind].data[i,0,0].x>freqgauche) and (und.spect[ind].data[i,0,0].x<freqdroite) then
       resultat:=resultat+(2*ldb-und.spect[ind].data[i,0,0].z-und.spect[ind].data[i+1,0,0].z)/2;

calcul_aire:=-resultat;

end;

{**********************************************
traite le signal: fournit le spectre et calcul la polar.
}
procedure tPilotageRMNForm.traitespectre(nomsig,nombase,nomresult:string; var polar:real);
var freqgauche,freqdroite:real;
    indresult,indsig,indbase:integer;


begin
indsig:=und.indexof(nomsig);
indbase:=und.indexof(nombase);
indresult:=und.indexof(nomresult);

{creation au besoin}
if indresult=-1 then
   indresult:=CreatespectreRMN(nomresult);

und.spect[indresult].comment:=datetostr(date)+' '+timetostr(time)+' '+'signal';

freqgauche:=freqg.value;
freqdroite:=freqd.value;


{soustraction signal moins base }
formate(indsig,indbase,indresult);

polar:=calcul_aire(indresult,freqgauche,freqdroite);
polMain.value:=polar;
polOptions.value:=polar;

end;
{*************************************

*                                                   commande SYNTHE

{**************************************
realise un scan en frquence pour rglage}
procedure TPilotageRMNForm.scansyntheClick(Sender: TObject);
var freq,amp,niv,temps:real;
    moyennage:integer;
begin
freq:=strtofloat(freqacq.text);
amp:=strtofloat(ampacq.text);
niv:=strtofloat(nivacq.text);
moyennage:=moy.value;

AcquiStatus.caption:='Scan Synthe';
run.enabled:=false;

initacquisition(freq,amp,niv);

while not(stopflag) do
    begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
    end;

AcquiStatus.caption:='Attente';
run.enabled:=true;
end;
{***************************
}
procedure TPilotageRMNForm.onsyntheClick(Sender: TObject);
var freq,amp,niv:real;
begin
freq:=strtofloat(freqacq.text);
amp:=strtofloat(ampacq.text);
niv:=strtofloat(nivacq.text);

initacquisition(freq,amp,niv);

syntheon;
end;
{***************************
}
procedure TPilotageRMNForm.offsyntheClick(Sender: TObject);
begin
syntheoff;
end;
{***************************
}
procedure TPilotageRMNForm.initsynthe(freq,amp,niv:real);

var texte,Nivtext,Amptext:string;

begin
{initialisation frequence}
texte:='cfrq '+floattostr(freq)+'mhz';
sendSynthe(texte);

{initialisation niveau}
nivtext:=floattostr(niv);
texte:='rflv '+nivtext+'dbm';
sendSynthe(texte);

{initialisation modulation}
amptext:=floattostr(amp);
texte:='fm:devn '+amptext+'kHz;'+ent.text+';on';
sendSynthe(texte);
statusSynthe.Font.Color := clgreen;
statusSynthe.caption:='initialis';
end;
{***************************
                RUN}
procedure TPilotageRMNForm.runClick(Sender: TObject);
var freq,amp,niv,temps,polar:real;
begin

Scansynthe.enabled:=false;

freq:=strtofloat(freqacq.text);
amp:=strtofloat(ampacq.text);
niv:=strtofloat(nivacq.text);
initacquisition(freq,amp,niv);

if mode.text='Simple' then
   begin
   simple(npassage.value,moy.value,choixspectresig.text,choixspectrebase.text,base.checked,temps,polar);
   Scansynthe.enabled:=true;
   AcquiStatus.caption:='Attente';
   end;
   
if mode.text='f(t)' then
   begin
   compteur:=0;
   if calpol.checked then
      visupol.clearvisu;
   timeracqui.interval:=50;
   timeracqui.enabled:=true;
   end;

end;
{***************************
traite le signal et calcul la polar}
procedure TPilotageRMNForm.calculpolClick(Sender: TObject);
var polar:real;
begin
traitespectre(sigpol.text,basepol.text,spectrepol.text,polar);

end;

{***************************
petite procedure calculant la polar en fonction des choix de la fiche
l'initialisation de l'acquisition doit etre faite au prealable}
procedure TPilotageRMNForm.mesurepolar(n:integer;var polar,temps:real);

begin
acquisitionRunning:=true;
stopflag:=false;
simple(n,moy.value,choixspectresig.text,choixspectrebase.text,base.checked,temps,polar);
acquisitionRunning:=false;

end;
{ function qui renvoi true si une acquisition est en route }
{ et false sinon                                           }
Function TPilotageRMNForm.TestAcquis:boolean;
begin
     result:=acquisitionRunning;
end;

{*****************
**                              Sauvegarde et ouverture de config RMN
******************}
procedure TPilotageRMNForm.SaveConfigClick(Sender: TObject);
var f:textfile;
begin
saveConfigdia.initialDir:=boitnoir.RepertoireManip.text;
if saveConfigdia.execute then
  begin
  assignfile(f,saveConfigdia.FileName);
  rewrite(f);
  writeln(f,'** Config RMN **');
  writeln(f,'Nbr Passages;'+inttostr(npassage.value));
  writeln(f,'Moyennage;'+inttostr(moy.value));
  writeln(f,'FitBasMin;'+FitBasMin.text);
  writeln(f,'FitBasMax;'+FitBasMax.text);
  writeln(f,'FitHauMin;'+FitHauMin.text);
  writeln(f,'FitHauMax;'+FitHauMax.text);
  writeln(f,'Int Gauche;'+freqg.text);
  writeln(f,'Int Gauche;'+freqd.text);
  writeln(f,'Freq;'+freqacq.text);
  writeln(f,'Amp;'+AmpAcq.text);
  writeln(f,'Niv;'+Nivacq.text);
  writeln(f,'Vout1;'+Vout1.text);
  writeln(f,'Vout3;'+Vout3.text);
  writeln(f,'Vout4;'+Vout4.text);
  writeln(f,'Vout5;'+Vout5.text);
  closefile(f);
  end;
end;

procedure TPilotageRMNForm.LoadConfigClick(Sender: TObject);
var f:textfile;
    temp,temp2:string;
begin
OpenConfigdia.initialDir:=boitnoir.RepertoireManip.text;
if OpenConfigdia.execute then
  begin
  assignfile(f,OpenConfigdia.FileName);
  reset(f);
  readln(f,temp);
  if temp='** Config RMN **' then
    begin
    readln(f,temp);
    temp2:=copy(temp,pos(';',temp)+1,length(temp));
    Npassage.value:=strtoint(temp2);
    readln(f,temp);
    temp2:=copy(temp,pos(';',temp)+1,length(temp));
    Moy.value:=strtoint(temp2);
    readln(f,temp);
    FitBasMin.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    FitBasMax.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    FitHauMin.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    FitHauMax.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    freqg.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    freqd.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    freqacq.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    ampacq.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    Nivacq.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    Vout1.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    Vout3.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    Vout4.text:=copy(temp,pos(';',temp)+1,length(temp));

    readln(f,temp);
    Vout5.text:=copy(temp,pos(';',temp)+1,length(temp));

    end;
  closefile(f);
  end;
end;
{*************************************

*                                Ensembles de fonctions bes niveau (ancienement RMNbase)

{**************************************}
{********************************************
}
function TPilotageRMNForm.CreatespectreRMN(nom:string):integer;
var vind:integer;
begin
Vind:=und.addspectre(nom,256,1,1);
und.spect[vind].typex:='freq';
und.spect[vind].typey:='single';
und.spect[vind].ExpCondNbr:=0;

result:=vind;
end;

{****************************
commande le balayage du champ via la sortie Vout3}
procedure TpilotageRMNForm.SweepB(com:string);
var i:integer;
begin
if (com='base') and (statusfield.caption='Signal') then
   begin{modifie la tension de telecommande du champ pour activer l'alim}
   for i:=1 to 10 do
     begin
     setvout3(i-0.01);
     pause(strtofloat(Pausesweep.text));
     end;
   statusfield.caption:='Base';
   statusField.font.color:=clred;
   end;
if (com='signal') and (statusfield.caption='Base') then
    begin
    for i:=9 downto 0 do
      begin
      setvout3(i-0.01);
      pause(strtofloat(Pausesweep.text));
      end;
    statusfield.caption:='Signal';
    statusField.font.color:=clgreen;
    end;

pause(strtofloat(PauseSweepfin.text));
end;

{********************************************
}
procedure TpilotageRMNForm.setVout(sender:Tobject);
begin
if sender=vout1set then
   begin
   setVout1(Vout1.value);
   vout1ud.position:=round(Vout1.value*100);
   end;
if sender=vout3set then
   begin
   setVout3(Vout3.value);
   vout3ud.position:=round(Vout3.value*100);
   end;
if sender=vout4set then
   begin
   setVout4(Vout4.value);
   vout4ud.position:=round(Vout4.value*100);
   end;
if sender=vout5set then
   begin
   setVout5(Vout5.value);
   vout5ud.position:=round(Vout5.value*100);
   end;
end;
{********************
met en route la sortie rf et la modulation si besoin,
et effectue une pause}

procedure TpilotageRMNForm.syntheon;

var texte:string;

begin
texte:=sendSynthe('mod?');

if texte=':MOD:OFF' then
   begin
   sendSynthe('rflv:on');
   sendSynthe('mod:on');
   pause(3000);
   end;

end;

{*******************
arret de la rf et de la modulation}

procedure TpilotageRMNForm.syntheoff;

begin
sendSynthe('rflv:off');
sendSynthe('mod:off');
statusSynthe.Font.Color := clred;
statusSynthe.caption:=' initialis';
end;


procedure TPilotageRMNForm.freqAcqChange(Sender: TObject);
begin
statusSynthe.Font.Color := clred;
statusSynthe.caption:=' initialis';
end;


procedure TPilotageRMNForm.VoutudClick(Sender: TObject;
  Button: TUDBtnType);
begin
if sender=Vout1ud then
  begin
  vout1.value:=Vout1ud.position/100;
  setVout(vout1set);
  end;
if sender=Vout3ud then
  begin
  vout3.value:=Vout3ud.position/100;
  setVout(vout3set);
  end;
if sender=Vout4ud then
  begin
  vout4.value:=Vout4ud.position/100;
  setVout(vout4set);
  end;
if sender=Vout5ud then
  begin
  vout5.value:=Vout5ud.position/100;
  setVout(vout5set);
  end;
end;

procedure TPilotageRMNForm.Changefieldclick(Sender: TObject);
begin
if sender=bsig then  SweepB('signal');
if sender=bbase then  SweepB('base');
end;

end.
