unit RMNbases;
{unit de prise du signal RMN pour combinaison avec le programme de pilotage PAPOL
fonctions bas niveaux dans la gestion des cartes AT : initialisation des chaines d'acquisition,
dfinition des tats acquisition et saturation.
pilotage du synth
E.Leymarie 10/00

11.06.01: EL: creation de function TRMNbase.CreatespectreRMN(nom:string):integer;
              pour la creation de spectre und type RMN}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, editdata,AT_AOMIO,GPIB_CEC, ExtCtrls;


type
  TRMNbase = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    qmetre: TComboBox;
    chaineaff: TComboBox;
    entreent: TEdit;
    ctrgain: TComboBox;
    entreet: TEdit;
    react: TButton;
    compensation: TSpinEdit;
    group: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    freqacq: TEdit;
    nivacq: TEdit;
    ampacq: TEdit;
    ent: TComboBox;
    GroupBox1: TGroupBox;
    setVout1a: TCheckBox;
    Vout1a: TEdit;
    Label11: TLabel;
    P1a: TEdit;
    P5a: TEdit;
    setVout5a: TCheckBox;
    Vout5a: TEdit;
    Label12: TLabel;
    P3a: TEdit;
    setVout3a: TCheckBox;
    vout3a: TEdit;
    Label13: TLabel;
    P4a: TEdit;
    setVout4a: TCheckBox;
    Vout4a: TEdit;
    Label14: TLabel;
    GroupBox2: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    setVout1s: TCheckBox;
    vout1s: TEdit;
    P1s: TEdit;
    P5s: TEdit;
    setVout5s: TCheckBox;
    Vout5s: TEdit;
    P3s: TEdit;
    setVout3s: TCheckBox;
    Vout3s: TEdit;
    P4s: TEdit;
    setVout4s: TCheckBox;
    Vout4s: TEdit;
    Label19: TLabel;
    Relaia: TEdit;
    relais: TEdit;
    Label20: TLabel;
    Label23: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    GroupBox3: TGroupBox;
    Label21: TLabel;
    Label22: TLabel;
    Label24: TLabel;
    PauseSweep: TEdit;
    PauseSweepfin: TEdit;
    bsig: TButton;
    bbase: TButton;
    GroupBox4: TGroupBox;
    Vout1: TEdit;
    Vout1set: TButton;
    Vout3set: TButton;
    Vout3: TEdit;
    vout5: TEdit;
    Vout5set: TButton;
    vout4: TEdit;
    Vout4set: TButton;
    procedure FormCreate(Sender: TObject);
    function CreatespectreRMN(nom:string):integer;
    procedure pause(temps:real);
    procedure SweepB(com:string);
    procedure sweepchamp(sender:Tobject);
    procedure setVout(sender:Tobject);

    function chaine:integer;
    procedure initchaine;
    procedure reactualiseentree(sender:tobject);

    procedure initsynthe(freq,amp,niv:real);
    procedure initirrad(freq,amp,niv:real;source:string);
    procedure synthe_acquisition;
    procedure synthe_sature(t:real);
    procedure syntheon;
    procedure syntheoff;

  private
    { Dclarations prives}
   
    frequence,niveau,amplitude,entree:string;
  public
    { Dclarations publiques}
    gain:integer;
  end;

var
  RMNbase: TRMNbase;

const
     adressesynthe=10; {adresse GPIB du synthe}

implementation

{$R *.DFM}

procedure TRMNbase.FormCreate(Sender: TObject);
var ind,i:integer;
begin
CreatespectreRMN('Signal1');
CreatespectreRMN('Signal1t');
CreatespectreRMN('Signal2');
CreatespectreRMN('Signal2t');
CreatespectreRMN('base');

initatao;
initatmio;
initdac1;
end;
{********************************************
}
function TRMNbase.CreatespectreRMN(nom:string):integer;
var vind:integer;
begin
Vind:=und.addspectre(nom,256,1,1);
und.spect[vind].typex:='freq';
und.spect[vind].typey:='single';
und.spect[vind].ExpCondNbr:=0;

result:=vind;
end;
{********************************************

*              partie controle general

***********************************************}
{commande une pause de temps msec}
procedure TRMNbase.pause(temps:real);

var t0,t:real;

begin
t0:=(time-int(time))*86400;  {temps en s}
repeat
      t:=(time-int(time))*86400;
until ((t-t0)*1000>temps)
end;

{****************************
commande le balayage du champ via la sortie Vout3}
procedure TRMNbase.SweepB(com:string);
var i:integer;
begin
if com='base' then
   {modifie la tension de telecommande du champ pour activer l'alim}
   for i:=1 to 10 do
     begin
     setvout3(i-0.01);
     pause(strtofloat(Pausesweep.text));
     end
else
    for i:=9 downto 0 do
    begin
    setvout3(i-0.01);
    pause(strtofloat(Pausesweep.text));
    end;

pause(strtofloat(PauseSweepfin.text));
end;
{********************************************
}
procedure TRMNbase.sweepchamp(sender:Tobject);
begin
if sender=bsig then
   SweepB('acquisition')
else
   SweepB('base');
end;
{********************************************
}
procedure TRMNbase.setVout(sender:Tobject);
begin
if sender=vout1set then
   setVout1(strtofloat(Vout1.text));
if sender=vout3set then
   setVout3(strtofloat(Vout3.text));
if sender=vout4set then
   setVout4(strtofloat(Vout4.text));
if sender=vout5set then
   setVout5(strtofloat(Vout5.text));
end;
{********************************************

*              partie controle entree

***********************************************}

{************************************}
{donne le numero de chaine en fonction des choix}
function TRMNbase.chaine:integer;
begin
if (qmetre.text='0') then
   begin
   if (chaineaff.text='mixer') then
      chaine:=1
   else
       chaine:=3;
   end
else
    begin
    if (chaineaff.text='mixer') then
       chaine:=5
    else
       chaine:=7;
    end;
end;

{********************************
initialisation de l'entre en vue du spectre, tension de compensation
et initchannel}
procedure TRMNbase.initchaine;

var offset:real;

begin

gain:=strtoint(ctrgain.text);
offset:=compensation.value/1000;

if  (chaineaff.text='diode comp') or  (chaineaff.text='mixer comp') then
begin
if (qmetre.text='0') then
      begin
      setvout2(offset);
      setvout0(0);
      end
   else
       begin
       setvout0(offset);
       setvout2(0);
       end;
end;

{initialisation channel}
initchannel(chaine,gain,false);

end;

{********************************}
{acquisition et affichage des tensions}
procedure TRMNbase.reactualiseentree(sender:tobject);

var resultat:word;
    resultatbip:smallint;

begin
if (compensation.text<>'') and (compensation.text<>'-') then
begin
initchaine;

{affichage du cannal non trait en bipolar}
initchannel(chaine+1,1,true);
lecture(5,resultat);
resultatbip:=resultat;
entreent.text:=floattostr(resultatbip/(3.2768));

{lecture chaine traite dans les conditions d'acquisition}
initchaine;
lecture(5,resultat);
entreet.text:=floattostr(resultat/(6.5538*gain));
end;

end;
{********************************************

*              partie controle synthe

***********************************************}


{************************
initialise  la frquence centrale, l'amplitude de modulation du synth
INPUT freq : frequence centrale
      amp  : amplitude de modulation en kHz
      niv  : niveau en dBm
      implicite: ent = choix de l'entree de modulation en fonction du choix de la fiche}

procedure TRMNbase.initsynthe(freq,amp,niv:real);

var texte:string;

begin
{initialisation frequence}
texte:='cfrq '+floattostr(freq)+'mhz';
gpibsend(adressesynthe,texte);

{initialisation niveau}
niveau:=floattostr(niv);
texte:='rflv '+niveau+'dbm';
gpibsend(adressesynthe,texte);

{initialisation modulation}
amplitude:=floattostr(amp);
entree:=ent.text;
texte:='fm:devn '+amplitude+'kHz;'+entree+';on';
gpibsend(adressesynthe,texte);

end;
{************************
initialise  la frquence centrale, l'amplitude de modulation du synth pour une irradiation
INPUT freq : frequence centrale
      amp  : amplitude de modulation en kHz
      niv  : niveau en dBm
      source: F1,F2,... suivant la source interne}

procedure TRMNbase.initirrad(freq,amp,niv:real;source:string);

var texte:string;

begin
{initialisation frequence}
texte:='cfrq '+floattostr(freq)+'mhz';
gpibsend(adressesynthe,texte);

{initialisation niveau}
niveau:=floattostr(niv);
texte:='rflv '+niveau+'dbm';
gpibsend(adressesynthe,texte);

{initialisation modulation}
amplitude:=floattostr(amp);
entree:=ent.text;
texte:='fm:devn '+amplitude+'kHz;'+'INT'+source+';on';
gpibsend(adressesynthe,texte);

end;
{*****************************************************
set les tensions en mode acquisition
INPUT : implicite les 4 valeurs de tension ainsi que les pauses associes
Rq: les pauses sont toujours respectes}
procedure TRMNbase.synthe_acquisition;
var texte:string;
begin
if setvout1a.checked then
   setVout1(strtofloat(Vout1a.text));
pause(strtofloat(P1a.text));

if setvout3a.checked then
   setVout3(strtofloat(Vout3a.text));
pause(strtofloat(P3a.text));

{modifie la tension vout6: relai RF en mode acquisition}
setvout6(strtofloat(relaia.text));

if setvout4a.checked then
   setVout4(strtofloat(Vout4a.text));
pause(strtofloat(P4a.text));

if setvout5a.checked then
   setVout5(strtofloat(Vout5a.text));
pause(strtofloat(P5a.text));
end;
{*****************************************************
set les tensions en mode saturation, effectue une pause, reinitialise le mode acquisition
INPUT : implicite les 4 valeurs de tension ainsi que les pauses associes
        t: dure de la saturation en msec
Rq: les pauses sont toujours respectes}
procedure TRMNbase.synthe_sature(t:real);
var texte:string;
begin

if setvout5s.checked then
   setVout5(strtofloat(Vout5s.text));
pause(strtofloat(P5s.text));

if setvout4s.checked then
   setVout4(strtofloat(Vout4s.text));
pause(strtofloat(P4s.text));

{modifie la tension vout6: relai RF en mode saturation}
setvout6(strtofloat(relais.text));

if setvout3s.checked then
   setVout3(strtofloat(Vout3s.text));
pause(strtofloat(P3s.text));

if setvout1s.checked then
   setVout1(strtofloat(Vout1s.text));
pause(strtofloat(P1s.text));


{effectue une pause pour la saturation}
pause(t);

{retour en mode acquisition}
synthe_acquisition;

end;

{********************
met en route la sortie rf et la modulation si besoin,
et effectue une pause}

procedure tRMNbase.syntheon;

var texte:string;

begin
gpibsend(adressesynthe,'mod?');
gpibread(adressesynthe,texte,10);

if texte=':MOD:OFF' then
   begin
   gpibsend(adressesynthe,'rflv:on');
   gpibsend(adressesynthe,'mod:on');
   pause(3000);
   end;

end;

{*******************
arret de la rf et de la modulation}

procedure tRMNbase.syntheoff;

begin

gpibsend(adressesynthe,'rflv:off');
gpibsend(adressesynthe,'mod:off');

end;


end.
