unit comptage2DTOF;

{*******************************************
programme de pilotage de l'acquisition des neutrons en mode TOF
{ E.Leymarie 7/00                   }

{ MODIFICATIONS                                                                     }
{ 10/00 modification : rcriture et nouvelles fonctions pour cable dcal de 3 bits }
{ 28/11/00 :Edouard : modification de la procedure de rcupration des datas afin de ne pas}
{ perdre les spectres si ils portent le meme nom}
{11/12/00 : modifications en vue de l'utilisation de frames de duree variable}
{17/01/01 : Edouard : modifications pour utilisation de l'index fichier
          creation de savespectre, destruction de testnomfich et d'objets sur la fiche
          + cosmtique boite noire}
{27.03.01 :EL :modifications pour jumelage avec traitement:
               modification spectre.addspectre(X,Y) en spectre.addspectre(X,Y,1)
{11.06.01: EL: cration de la fonction Tcomptage2Dform.CreatePAPOLSpectre(nom:string):integer
               qui declare proprement des spectres pour PAPOL
}
{*********************  Version 2 **********************}
{17/09/01 : profondes modifs suite au changement de la partie hard. En vu de la possibilit de faire 2*32 frames
avec l'utilisation d'un detecteur 64*64}

{version a jour le 19.01.01}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, operations, ExtCtrls, Grids, Graph2D, editdata, Spin,
  AT_AOMIO, Menus, EditReal, EUROPSD, Math;

const
wm_redessine=$403+wm_user;

type
  Tcomptage2DTOFform = class(TForm)
    Label1: TLabel;
    timeracquisition2D: TTimer;
    Label3: TLabel;
    timeracquisitionTOF: TTimer;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    choixpolar: TComboBox;
    choixmode: TComboBox;
    acquisitionTOF: TButton;
    previsualisation: TButton;
    STOPbutton: TButton;
    PopupMenu1: TPopupMenu;
    rebootage: TMenuItem;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label7: TLabel;
    nbrframe: TSpinEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Choixspectreup: TComboBox;
    choixspectredown: TComboBox;
    parametres: TStringGrid;
    Label14: TLabel;
    choixcable: TComboBox;
    retard: TEditReal;
    Label6: TLabel;
    validationTOF: TButton;
    Label32: TLabel;
    iden: TEditReal;
    Identique: TButton;
    Label33: TLabel;
    Tzero: TEditReal;
    Label34: TLabel;
    raison: TEditReal;
    Geometrique: TButton;
    Label35: TLabel;
    dureeform: TEditReal;
    Label9: TLabel;
    tableframe: TStringGrid;
    Label8: TLabel;
    Npars: TEditReal;
    Mpars: TEditReal;
    defTT: TEditReal;
    defTup: TEditReal;
    defTdown: TEditReal;
    enregistrement: TMenuItem;
    Labelsave: TLabel;
    verifframe: TButton;
    status: TLabel;
    procedure FormCreate(Sender: TObject);
    Function TestAcquis:boolean;
    function CreatePAPOLSpectre(nom:string):integer;
    function CreatePAPOLTOFSpectre(nom:string;nbrframe:integer):integer;
    Procedure NbrFrameMaxChange;
    procedure gestionfiche(Sender: TObject);
    procedure parametrescell_zero;
    procedure stop;
    procedure ChoixspectreClick(Sender: TObject);
    procedure savespectre(ind:integer;ext:string;var filename:string);
    procedure savespectre3D(ind:integer;ext:string;var filename:string);

    procedure acquisition2D(TT,TU,TD:real;polar:string;indexspectreU,indexspectreD:integer);
    procedure timeracquisition2DTimer(Sender: TObject);
    procedure previsualisation2D;

    procedure acquisitionTOFframe(TT,TU,TD:real;polar:string;indexspectreU,indexspectreD:integer;retard:real;nbrframe:integer);
    procedure timeracquisitionTOFTimer(Sender: TObject);

    procedure intitialisationTOF;
    procedure rebootageTOF;
    procedure StartTOF;
    procedure ReadDataTOF;

    procedure acquisitionTOFClick(Sender: TObject);
    procedure previsualisationClick(Sender: TObject);
    procedure STOPbuttonClick(Sender: TObject);
    procedure rebootageClick(Sender: TObject);
    procedure choixcableChange(Sender: TObject);
    procedure validationTOFClick(Sender: TObject);
    procedure acquisitionSimple2D(TT:integer);
    procedure IdentiqueClick(Sender: TObject);
    procedure GeometriqueClick(Sender: TObject);
    procedure enregistrementClick(Sender: TObject);
    procedure verifframeClick(Sender: TObject);
  private
    { Dclarations prives}
    polarisationup:Boolean; {true si l'acquisition est en up (en mode TOF)}
    numerospectreU,numerospectreD:integer; {designe le spectre recepteur dans une acquisition statique}
    mode,modepolar:string; {designe le mode d'acquisition en cours}
    stopflag:boolean;
    decalageencours:integer; {3 ou 4 selon le cable}
    duree:real;
    tailleDetec:integer; {taille en cours du detecteur}
    NbrFrameMax:integer; {nombre maxi de frame possible}
    MUtemp,MDtemp:real;      {permet de stoker le moniteur de la serie de frames precedente}
  public
    { Dclarations publiques}

  end;

var
  comptage2DTOFform: Tcomptage2DTOFform;
  acquisitionRunning: boolean;

implementation

uses BoiteNoire, MainForm, RMNbases;

{$R *.DFM}

procedure Tcomptage2DTOFform.FormCreate(Sender: TObject);
var i:integer;
    filename:string;
    
begin
{deuxd.createframe; cree 16 spectres frame}
tailleDetec:=64;
CreatePAPOLTOFSpectre('AcqTOFup',2);
CreatePAPOLTOFSpectre('AcqTOFdown',2);
NbrFrameMax:=32;
{initialisation du tableau parametre}
parametres.cells[0,0]:='coups';
parametres.cells[1,0]:='moniteur';
parametres.cells[2,0]:='temps';
{initialisation du tableau frame}
NbrFrameMaxChange;

{initialisation des items des choixspectre}
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
begin
choixspectreup.items.add(deuxd.spect[i].nom);
choixspectredown.items.add(deuxd.spect[i].nom);
end;
choixspectreup.text:=deuxd.spect[1].nom;
choixspectredown.text:=deuxd.spect[2].nom;

{cable par defaut}
decalageencours:=5;

end;
{ *****************************************
  function qui renvoi true si une acquisition est en route }
{ et false sinon                                           }
Function Tcomptage2DTOFform.TestAcquis:boolean;
begin
     result:=acquisitionRunning;
end;
{*******************************}
Procedure Tcomptage2DTOFform.NbrFrameMaxChange;
var i,j:integer;
begin

if NbrframeMax=32 then
   begin
   tableframe.rowcount:=5;
   tableframe.height:=128;
   for i:=1 to 8 do
    tableframe.cells[i,0]:=inttostr(i);
   tableframe.cells[0,1]:='1  8';
   tableframe.cells[0,2]:='9  16';
   tableframe.cells[0,3]:='17  24';
   tableframe.cells[0,4]:='25  32';
   end;
if NbrframeMax=16 then
   begin
   tableframe.rowcount:=3;
   tableframe.height:=78;
   for i:=1 to 8 do
    tableframe.cells[i,0]:=inttostr(i);
   tableframe.cells[0,1]:='1  8';
   tableframe.cells[0,2]:='9  16';
   end;
if NbrframeMax=8 then
   begin
   tableframe.rowcount:=2;
   tableframe.height:=54;
   for i:=1 to 8 do
    tableframe.cells[i,0]:=inttostr(i);
   tableframe.cells[0,1]:='1  8';
   end;

end;

{ *****************************************
fonction qui cree un spectre 2D au format PAPOL
*************}
function Tcomptage2DTOFform.CreatePAPOLSpectre(nom:string):integer;
var vind,i,j:integer;
begin
Vind:=deuxd.addspectre(nom,tailleDetec,tailleDetec,1);
deuxd.spect[vind].typex:='raw';
deuxd.spect[vind].typey:='raw';
deuxd.spect[vind].typeLT:='raw';

for i:=0 to tailleDetec-1 do
for j:=0 to tailleDetec-1 do
    begin
    deuxd.spect[vind].data[i,j,0].x:=i;
    deuxd.spect[vind].data[i,j,0].y:=j;
    deuxd.spect[vind].data[i,j,0].LT:=1;
    end;
result:=vind;
end;
{ *****************************************
fonction qui cree un spectre 3D au format PAPOL
*************}
function Tcomptage2DTOFform.CreatePAPOLTOFSpectre(nom:string;nbrframe:integer):integer;
var vind,i,j,l:integer;
begin
Vind:=troisd.addspectre(nom,tailleDetec,tailleDetec,nbrframe);
troisd.spect[vind].typex:='raw';
troisd.spect[vind].typey:='raw';
troisd.spect[vind].typeLT:='raw';

for l:=0 to nbrframe-1 do
   for i:=0 to tailleDetec-1 do
   for j:=0 to tailleDetec-1 do
     begin
      troisd.spect[vind].data[i,j,l].x:=i;
      troisd.spect[vind].data[i,j,l].y:=j;
      troisd.spect[vind].data[i,j,l].LT:=l;
     end;
result:=vind;
end;
{********************************************
gestion de la fiche en fonction du mode choisie}
procedure Tcomptage2DTOFform.gestionfiche(Sender: TObject);
begin

if (choixmode.text='simple') then
   begin
   if sender=choixmode then showmessage('brancher le LEMO STOP IN');
   acquisitionTOF.enabled:=true;
   previsualisation.enabled:=true;
   stopbutton.enabled:=true;
   rebootage.enabled:=true;
   GroupBox1.visible:=false;
   choixspectreup.enabled:=false;
   choixspectredown.enabled:=false;

   if (choixpolar.text='UP') or (choixpolar.text='UP/DOWN') then
      choixspectreup.enabled:=true;

   if (choixpolar.text='DOWN') or (choixpolar.text='UP/DOWN') then
      choixspectredown.enabled:=true;

   if (choixpolar.text='UP/DOWN') then
      begin
      defTup.enabled:=true;
      defTdown.enabled:=true;
      end;
   end;
if (choixmode.text='TOF') then
   begin
   if sender=choixmode then showmessage('dbrancher le LEMO STOP IN');
   acquisitionTOF.enabled:=true;
   previsualisation.enabled:=true;
   stopbutton.enabled:=true;
   rebootage.enabled:=true;
   GroupBox1.visible:=true;
   choixspectreup.enabled:=true;
   choixspectredown.enabled:=true;
   end;
if (choixmode.text='TOF/batch') then
   begin
   if sender=choixmode then showmessage('dbrancher le LEMO STOP IN');
   acquisitionTOF.enabled:=false;
   previsualisation.enabled:=false;
   stopbutton.enabled:=false;
   rebootage.enabled:=false;
   GroupBox1.visible:=true;
   choixspectreup.enabled:=true;
   choixspectredown.enabled:=true;

   end;


end;
{*******************************************
*}
procedure Tcomptage2DTOFform.parametrescell_zero;
begin
parametres.cells[0,1]:='0';
parametres.cells[1,1]:='0';
parametres.cells[2,1]:='0';

parametres.cells[0,2]:='0';
parametres.cells[1,2]:='0';
parametres.cells[2,2]:='0';

parametres.cells[0,3]:='0';
parametres.cells[1,3]:='0';
parametres.cells[2,3]:='0';
end;
{*******************************************
*}
procedure Tcomptage2DTOFform.choixcableChange(Sender: TObject);
begin
if choixcable.text='dcalage 3 bits' then
   begin {detecteur 128*128, possiblit UP/DOWN et limitation  8 frames}
   showmessage('brancher le cable 3 bits et le lemo flipper sur s2');
   if choixpolar.items.count=2 then choixpolar.items.add('UP/DOWN');
   decalageencours:=3;
   nbrframe.maxvalue:=8;
   nbrframe.value:=8;
   NbrFrameMax:=8;
   NbrFrameMaxChange;
   tailledetec:=128;
   end;
if choixcable.text='dcalage 4 bits' then
   begin {detecteur 128*128, possiblit UP ou DOWN et limitation  16 frames}
   showmessage('brancher le cable 4 bits et debrancher le lemo flipper de s2');
   if choixpolar.items.count=3 then choixpolar.items.delete(2);
   decalageencours:=4;
   nbrframe.maxvalue:=16;
   nbrframe.value:=16;
   NbrFrameMax:=16;
   NbrFrameMaxChange;
   tailledetec:=128;
   end;
if choixcable.text='dcalage 5 bits' then
   begin  {detecteur 64*64, possiblit UP/DOWN et limitation  32 frames}
   showmessage('brancher le cable 5 bits et brancher le lemo flipper de s2');
   if choixpolar.items.count=2 then choixpolar.items.add('UP/DOWN');
   decalageencours:=5;
   nbrframe.maxvalue:=32;
   nbrframe.value:=32;
   NbrFrameMax:=32;
   NbrFrameMaxChange;
   tailledetec:=64;
   end;
end;
{*******************************************
*}
procedure Tcomptage2DTOFform.ChoixspectreClick(Sender: TObject);
var i:integer;
begin
{initialisation des items des choixspectres a chaque ouverture}
choixspectreup.items.clear;
choixspectredown.items.clear;

if (choixmode.text='simple') then
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
   begin
   choixspectreup.items.add(deuxd.spect[i].nom);
   choixspectredown.items.add(deuxd.spect[i].nom);
   end;

if (choixmode.text='TOF') or (choixmode.text='TOF/batch')  then
for i:=1 to totalspectre do
if troisd.spect[i]<>nil then
   begin
   choixspectreup.items.add(troisd.spect[i].nom);
   choixspectredown.items.add(troisd.spect[i].nom);
   end;
end;


{*******************************************
*}
procedure Tcomptage2DTOFform.stop;
begin
if (mode='simple') or (mode='TOF') then
   begin
   operationform.suspendrecomptage;
   end;
if mode='TOFAlterne' then
   begin
   timeracquisition2D.enabled:=false;
   readDataTOF;
   operationform.suspendrecomptage;
   end;
stopflag:=true;
acquisitionRunning:=false;

end;
{*******************************************
procedure de sauvegarde des spectres : gestion de l'indexfichier et du nom de fichier (li  la boite noire)
INPUT ind : index du spectre  sauvegarder,
      ext:extension du fichier,
OUPUT filename : chemin+nom utilis pour la sauvegarde}
procedure Tcomptage2DTOFform.savespectre(ind:integer;ext:string;var filename:string);

begin
if labelsave.visible=false then
begin
IncIndexFichierCrt; {incrementation de l'index fichier}
filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+inttostr(GetIndexFichierCrt)+'.'+ext;
deuxd.spect[ind].SetExpCond('Num',GetIndexFichierCrt);
deuxd.spect[ind].save(filename);
end;
end;
{*******************************************
procedure de sauvegarde des spectres 3D: gestion de l'indexfichier et du nom de fichier (li  la boite noire)
INPUT ind : index du spectre  sauvegarder,
      ext:extension du fichier,
OUPUT filename : chemin+nom utilis pour la sauvegarde}
procedure Tcomptage2DTOFform.savespectre3D(ind:integer;ext:string;var filename:string);

begin
if labelsave.visible=false then
begin
IncIndexFichierCrt; {incrementation de l'index fichier}
filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+inttostr(GetIndexFichierCrt)+'.'+ext;
troisd.spect[ind].SetExpCond('Num',GetIndexFichierCrt);
troisd.spect[ind].save(filename);
end;
end;
{*******************************************
*           acquisition statique
******************************************* }

{************************************************
lance une acquisition 2D statique independante des choix de la fiche
INPUT TT,TU,TD temps en s
      polar designe le mode UP DOWN ou UP/DOWN   (UP/DOWN possible seulement si cable 0 ou 3 bits)
      indexspectre designe le spectre recepteur
OUPUT implicite modepolar
                numerospectreU, numerospectreD
                }
procedure Tcomptage2DTOFform.acquisition2D(TT,TU,TD:real;polar:string;indexspectreU,indexspectreD:integer);
begin
acquisitionTOF.enabled:=false;
status.caption:='Initialisation';
Application.ProcessMessages;
operationform.LancerAcquisition2D(decalageencours,TT,TU,TD,polar);
timeracquisition2D.enabled:=true;

stopflag:=false;
acquisitionRunning:=true;
modepolar:=polar;
mode:='simple';
numerospectreU:=indexspectreU;
numerospectreD:=indexspectreD;

parametrescell_zero;
status.caption:='Acquisition';

{gestion de la boite noire}
boitnoir.receivetext(timetostr(time)+': acquisition '+floattostr(TT)+' '+polar+' TU:'+floattostr(TU)+' TD:'+floattostr(TD));
end;

{*******************************************
charge et affiche les parametres acquisition Moniteur, coups, temps
teste la fin de l'acquisition
lance la recuperation des donnees dans les spectres specifis par numerospectre
INPUT implicite numerospectreU
                numerospectreD
                modepolar
OUTPUT implicite affichage
                 spectres}

procedure Tcomptage2DTOFform.Timeracquisition2Dtimer(Sender: TObject);
var NT,NU,ND:cardinal;
    MT,MU,MD,TT,TU,TD:real;
    filename:string;
begin

operationform.litparametre2D(NT,NU,ND,MT,MU,MD,TT,TU,TD);


{test de l'ouverture du faisceau}
if (TT>0.5) and (TT<1.5) then
   if MT<5 then
      begin
      timeracquisition2D.enabled:=false;
      MessageDlg('ATTENTION : faisceau probablement ferm ', mtWarning,[mbOk],0);
      timeracquisition2D.enabled:=true;
      end;

if operationform.Acquisition2DFinie or stopflag then
   begin {fin de l'acquisition}

   timeracquisition2D.enabled:=false;
   status.caption:='Lecture Data';
   Application.ProcessMessages;
   {gestion de l'enregistrement et de la boite noire}
   boitnoir.receivetext(timetostr(time)+' fin acquisition TT='+floattostr(TT));
   if (modepolar='UP') or (modepolar='UP/DOWN') then
      begin
      operationform.LireSpectre2D(decalageencours,numerospectreU,numerospectreD,'UP',Datetostr(date)+', '+timetostr(time)+' Acq: '+modepolar+' '+' spectre UP');
      savespectre(numerospectreU,'2Du',filename);
      boitnoir.receivetext('spectre UP N='+inttostr(NU)+' M='+floattostr(MU)+' save to '+filename);
      end;
   if (modepolar='DOWN') or (modepolar='UP/DOWN') then
      begin
      operationform.LireSpectre2D(decalageencours,numerospectreU,numerospectreD,'DOWN',Datetostr(date)+', '+timetostr(time)+' Acq: '+modepolar+' '+' spectre DOWN');
      savespectre(numerospectreD,'2Dd',filename);
      boitnoir.receivetext('spectre DOWN N='+inttostr(ND)+' M='+floattostr(MD)+' save to '+filename);
      end;
   sendmessage(principalform.handle,wm_redessine,0,0);
   acquisitionTOF.enabled:=true;
   acquisitionRunning:=false;
   status.caption:='Pause';
   end;

parametres.cells[0,1]:=inttostr(NT);
parametres.cells[1,1]:=floattostr(MT);
parametres.cells[2,1]:=floattostr(TT);

parametres.cells[0,2]:=inttostr(NU);
parametres.cells[1,2]:=floattostr(MU);

parametres.cells[0,3]:=inttostr(ND);
parametres.cells[1,3]:=floattostr(MD);
Npars.value:=NT/TT;
Mpars.value:=MT/TT;
end;

{*******************************************
lance une prvisualisation du mode statique
INPUT implicite polarisation, numeroframe, mode}
procedure Tcomptage2DTOFform.previsualisation2D;

begin
status.caption:='Lecture Data';
Application.ProcessMessages;
operationform.suspendrecomptage;
operationform.LireSpectre2D(decalageencours,numerospectreU,numerospectreD,modepolar,'PREVIEW');
operationform.reprendrecomptage;
sendmessage(principalform.handle,wm_redessine,0,0);
status.caption:='Acquisition';
end;

{*******************************************
*                            acquisition TOF  synchro externe


******************************************* }


{************************************************
lance une acquisition TOF  avec des paramtres independants des choix de la fiche
INPUT
OUPUT implicite polarisationup
                mode}
procedure Tcomptage2DTOFform.acquisitionTOFframe(TT,TU,TD:real;polar:string;indexspectreU,indexspectreD:integer;retard:real;nbrframe:integer);
var s:string;
begin

acquisitionTOF.enabled:=false;
previsualisation.enabled:=false;
status.caption:='Initialisation';
Application.ProcessMessages;

{positionnenment du flipper sur UP (permet un changement de spin au debut de l'acquisition)}
operationform.LancerPolFixe(1,false);
repeat
until operationform.Acquisition2DFinie;

{fermeture synchro EUROPSD}
setvout1(0);

{debut comptage}
operationform.initcompteurenTOF(retard,duree,nbrframe);
if polar='UP/DOWN' then
   operationform.LancerPolAlter(TT,TU,TD)
else operationform.LancerPolFixe(TT,polar='UP');

timeracquisitionTOF.enabled:=true;

numerospectreU:=indexspectreU;
numerospectreD:=indexspectreD;
stopflag:=false;
acquisitionRunning:=true;
modepolar:=polar;
mode:='TOF';
parametrescell_zero;
status.caption:='Acquisition';
{gestion de la boite noire}
s:=timetostr(time)+': Acquisition TOF '+floattostr(TT)+'s, '+polar;
boitnoir.receivetext(s); 

end;

{*******************************************
charge et affiche les parametres acquisition Moniteur, coups, temps
teste la fin de l'acquisition
lance la recuperation des donnees dans les spectres def par createframe
INPUT implicite polarisationup
                indexframe (editdata) designe les spectres a charger
OUTPUT implicite affichage
                 spectres}
procedure Tcomptage2DTOFform.timeracquisitionTOFTimer(Sender: TObject);
var NT,NU,ND:cardinal;
    MT,MU,MD,TT,TU,TD:real;
    i:integer;
    comment,filename:string;

begin

operationform.litparametre2D(NT,NU,ND,MT,MU,MD,TT,TU,TD);
if operationform.Acquisition2DFinie or stopflag then
   begin
   timeracquisitionTOF.enabled:=false;
   status.caption:='Lecture Data';
   Application.ProcessMessages;
   comment:=timetostr(time)+': fin TOF N='+inttostr(NT)+' M='+floattostr(MT);
   operationform.LireSpectre2D_TOF(numerospectreU,numerospectreD,decalageencours,modepolar,'TOF externe: '+timetostr(time));
   boitnoir.receivetext(comment);
   {rafraichissement fenetres 2D}
   sendmessage(principalform.handle,wm_redessine,0,0);
   {gestion de l'enregistrement}
   savespectre3D(numerospectreU,'3Du',filename);
   boitnoir.receivetext('spectre UP N='+inttostr(NU)+' M='+floattostr(MU)+' save to '+filename);
   savespectre3D(numerospectreD,'3Dd',filename);
   boitnoir.receivetext('spectre DOWN N='+inttostr(ND)+' M='+floattostr(MD)+' save to '+filename);
   {rinitialisation fin d'acquisition}
   if choixmode.text='TOF' then
   begin
   previsualisation.enabled:=true;
   acquisitionTOF.enabled:=true;
   end;
   acquisitionRunning:=false;
   status.caption:='Pause';
   end;

{deconnection de la synchro T0 pendant le comptage de la dernire alternance down
evite le depart de l'EUROPSD sur le retour du flippeur a sa position initiale}

if (operationform.EtatSpin='DOWN') and (TT>defTT.value) then
   setvout1(5);
   
{affichage des echelles de comptage}
parametres.cells[0,1]:=inttostr(NT);
parametres.cells[1,1]:=floattostr(MT);
parametres.cells[2,1]:=floattostr(TT);

parametres.cells[0,2]:=inttostr(NU);
parametres.cells[1,2]:=floattostr(MU);

parametres.cells[0,3]:=inttostr(ND);
parametres.cells[1,3]:=floattostr(MD);
Npars.value:=NT/TT;
Mpars.value:=MT/TT;
end;
{************************************************************************************
*           ensemble de procedure TOF utilises pour la manip de croissance de bulles plarises
*
**************************************************************************************}
{********************************
initialisation TOF
initialise l'EUROPSD suivant les choix de la fiche}
procedure Tcomptage2DTOFform.intitialisationTOF;
var nomU,nomD,s:string;

begin
acquisitionTOF.enabled:=false;
previsualisation.enabled:=false;
{cration des spectres 3D avec vrification des noms}
nomU:=choixspectreup.text;
if nomU='' then nomU:='defaultU';
nomD:=choixspectredown.text;
if nomD='' then nomU:='defaultD';
if nomU=nomD then nomD:=nomU+'1';
numerospectreU:=CreatePAPOLTOFSpectre(nomU,nbrframe.value);
numerospectreD:=CreatePAPOLTOFSpectre(nomD,nbrframe.value);
{ouverture synchro EUROPSD}
setvout1(5);
{initialisation EuroPSD}
operationform.initcompteurenTOF(retard.value,duree,nbrframe.value);
{initialisation diverse}
stopflag:=false;
acquisitionRunning:=true;
modepolar:=choixpolar.text;
mode:='TOFAlterne';
parametrescell_zero;
timeracquisitionTOF.enabled:=true;
{initialisation des Moniteurs tampons}
MUtemp:=0;MDtemp:=0;

{lancement du comptage}
operationform.LancerPolAlter(defTT.value,defTUp.value,defTDown.value);
{gestion de la boite noire}
s:=timetostr(time)+': Acquisition TOF TT: '+floattostr(defTT.value)+' TU: '+floattostr(defTup.value)+' TD: '+floattostr(defTdown.value);
boitnoir.receivetext(s);
end;
{********************************
commande de rebootage}
procedure Tcomptage2DTOFform.rebootageTOF;
var nomU,nomD:string;

begin
if not acquisitionRunning then
begin
acquisitionTOF.enabled:=false;
previsualisation.enabled:=false;
{cration des spectres 3D avec vrification des noms}
nomU:=choixspectreup.text;
if nomU='' then nomU:='defaultU';
nomD:=choixspectredown.text;
if nomD='' then nomU:='defaultD';
if nomU=nomD then nomD:=nomU+'1';
numerospectreU:=CreatePAPOLTOFSpectre(nomU,nbrframe.value);
numerospectreD:=CreatePAPOLTOFSpectre(nomD,nbrframe.value);

{initialisation diverse}
stopflag:=false;
acquisitionRunning:=true;
modepolar:=choixpolar.text;
mode:='TOFAlterne';
parametrescell_zero;
timeracquisitionTOF.enabled:=true;
{initialisation des Moniteurs tampons}
MUtemp:=0;MDtemp:=0;

end;
end;

{********************************
permet le dpart de L'EuroPSD sur une alternance UP}
procedure Tcomptage2DTOFform.startTOF;

begin
status.caption:='Initialisation';
application.processmessages;
RazEuroPSD;
status.caption:='attente comptage Down';
repeat  {attente du comptage sur periode 2 }
application.processmessages;
until (operationform.EtatSpin='DOWN') or (not acquisitionRunning);
{fermet interupteur: pres pour debut periode up}
setvout1(0);
status.caption:='Acquisition';
application.processmessages;
end;

{***************************
permet d'attendre la fin d'une paire d'alternance et de rcuperer les data}
procedure Tcomptage2DTOFform.ReadDataTOF;
var NT,NU,ND:cardinal;
    MT,MU,MD,TT,TU,TD:real;
    i:integer;
    filename:string;

begin
status.caption:='attente comptage Down';
application.processmessages;
repeat {attente du comptage de la deuxieme periode}
application.processmessages;
until (operationform.EtatSpin='DOWN') or (not acquisitionRunning);

{ouvrir T0  }
setvout1(5);
status.caption:='attente comptage UP';
application.processmessages;

repeat  {attente du comtage de la premiere periode}
application.processmessages;
until (operationform.EtatSpin='UP') or (not acquisitionRunning);

status.caption:='Lecture Data';
application.processmessages;

{ comptage periode 2 termine, pas de comptage sur priode 1}
operationform.litparametre2D(NT,NU,ND,MT,MU,MD,TT,TU,TD);
{recup des data}
operationform.LireSpectre2D_TOF(numerospectreU,numerospectreD,decalageencours,modepolar,'TOF: '+timetostr(time));
boitnoir.receivetext(timetostr(time)+': Read data TOF TT='+floattostr(TT)+' N='+inttostr(NT)+' MU='+floattostr(MU)+' MD='+floattostr(MD));
{gestion des moniteurs           }
troisd.spect[numerospectreU].moniteur:=MU-MUtemp;
troisd.spect[numerospectreD].moniteur:=MD-MDtemp;
{gestion de l'enregistrement}
savespectre3D(numerospectreU,'3Du',filename);
boitnoir.receivetext('spectre UP N='+inttostr(NU)+' M='+floattostr(MU-MUtemp)+' save to '+filename);
savespectre3D(numerospectreD,'3Dd',filename);
boitnoir.receivetext('spectre DOWN N='+inttostr(ND)+' M='+floattostr(MD-MDtemp)+' save to '+filename);
{rafraichissement fenetres 2D}
sendmessage(principalform.handle,wm_redessine,0,0);
MUtemp:=MU;
MDtemp:=MD;
status.caption:='Fin TOF';
end;

{***************************************
***                             gestion des boutons}
{*******************************************
lance les acquisitions}
procedure Tcomptage2DTOFform.acquisitionTOFClick(Sender: TObject);
var  polar:boolean;
     indUP,indDown:integer;

begin
polar:=(choixpolar.text='UP');

if choixmode.text='simple' then
   begin
   indup:=CreatePAPOLSpectre(choixspectreup.text);
   indDown:=CreatePAPOLSpectre(choixspectredown.text);
   acquisition2D(defTT.value,defTup.value,defTdown.value,choixpolar.text,indup,inddown);
   end;
if choixmode.text='TOF' then
   begin
   indup:=CreatePAPOLTOFSpectre(choixspectreup.text,nbrframe.value);
   indDown:=CreatePAPOLTOFSpectre(choixspectredown.text,nbrframe.value);
   acquisitionTOFframe(defTT.value,defTup.value,defTdown.value,choixpolar.text,indup,inddown,retard.value,nbrframe.value);
   end;


end;
{*******************************************
lance une prvisualisation}
procedure Tcomptage2DTOFform.previsualisationClick(Sender: TObject);
begin
if mode='simple' then previsualisation2D;

end;

procedure Tcomptage2DTOFform.STOPbuttonClick(Sender: TObject);
begin
stop;
end;
{************************************
permet de reprendre une acquisition apres plantage
les parametres de l'acquisition doivent etre mis a l'identiques}
procedure Tcomptage2DTOFform.rebootageClick(Sender: TObject);

var  polar:boolean;
     indUP,indDown:integer;

begin

   indup:=CreatePAPOLSpectre(choixspectreup.text);
   indDown:=CreatePAPOLSpectre(choixspectredown.text);

if choixmode.text='simple' then
    begin
    timeracquisition2D.enabled:=true;
    stopflag:=false;
    modepolar:=choixpolar.text;
    mode:='simple';
    numerospectreU:=indup;
    numerospectreD:=inddown;
    acquisitionTOF.enabled:=false;
    end;
{if choixmode.text='TOF' then
    begin
    timeracquisitionTOF.enabled:=true;
    polarisationup:=polar;
    mode:='TOF';
    end;

 }
end;
{*******************************************
lancement d'une acquisition simple de TT seconde
les autres choix sont conformes a la fiche}
procedure Tcomptage2DTOFform.acquisitionSimple2D(TT:integer);
var  indUP,indDown:integer;
begin

indup:=deuxd.indexof(choixspectreup.text);
if indup=-1 then
   indup:=CreatePAPOLSpectre(choixspectreup.text);

inddown:=deuxd.indexof(choixspectredown.text);
if inddown=-1 then
   inddown:=CreatePAPOLSpectre(choixspectredown.text);

acquisition2D(TT,defTup.value,defTdown.value,choixpolar.text,indup,inddown);

end;
{*******************************
                                Gestion duree frames
********************}

procedure Tcomptage2DTOFform.validationTOFClick(Sender: TObject);
var temps:array of real;
    i,j:integer;
    temp:string;
begin
setlength(temps,NbrFrameMax);
for i:=1 to (Nbrframemax div 8) do
    for j:=1 to 8 do
     temps[i*8+j-9]:=strtofloat(tableframe.cells[j,i]);

param_TOF_var(temps,nbrframe.value,duree);

dureeform.value:=duree;

boitnoir.receivetext('nouvelle dfinition des frames (en ms)');
for i:=1 to (nbrframe.value div 4) do
       boitnoir.receivetext(inttostr((i-1)*4+1)+' : '+ floattostr(temps[(i-1)*4])+#9+inttostr((i-1)*4+2)+' : '+ floattostr(temps[(i-1)*4+1])
       +#9+inttostr((i-1)*4+3)+' : '+ floattostr(temps[(i-1)*4+2])+#9+inttostr((i-1)*4+4)+' : '+ floattostr(temps[(i-1)*4+3]));
end;
{*******************************
creation auto de la duree des frames :identique}
procedure Tcomptage2DTOFform.IdentiqueClick(Sender: TObject);
var temps:array of real;
    i,j:integer;

begin
setlength(temps,NbrFrameMax);
for i:=0 to NbrFrameMax-1 do
    temps[i]:=iden.value;

param_TOF_var(temps,nbrframe.value,duree);
dureeform.value:=duree;
for i:=1 to (Nbrframemax div 8) do
    for j:=1 to 8 do
    tableframe.cells[j,i]:=floattostr(temps[i*8+j-9]);


end;
{*******************************
creation auto de la duree des frames :Geometrique}
procedure Tcomptage2DTOFform.GeometriqueClick(Sender: TObject);
var temps:array of real;
    i,j:integer;

begin
setlength(temps,NbrFrameMax);
for i:=0 to NbrFrameMax-1 do
    temps[i]:=Tzero.value*power(raison.value,i);

param_TOF_var(temps,nbrframe.value,duree);
dureeform.value:=duree;
for i:=1 to (Nbrframemax div 8) do
    for j:=1 to 8 do
    tableframe.cells[j,i]:=floattostr(temps[i*8+j-9]);
    
end;
{permet de supprimer l'enregistrement automatique des spectres}
procedure Tcomptage2DTOFform.enregistrementClick(Sender: TObject);
begin
if labelsave.visible=false then
   begin
   popupmenu1.items[1].caption:='retablir enregistrement';
   labelsave.visible:=true;
   end
else
   begin
   popupmenu1.items[1].caption:='supprimer enregistrement';
   labelsave.visible:=false;
   end;
end;

procedure Tcomptage2DTOFform.verifframeClick(Sender: TObject);
var temps:array of real;
    i:integer;
begin
setlength(temps,32);
Lit_param_TOF_var(temps,32,duree);
for i:=1 to nbrframe.value do
       boitnoir.receivetext(inttostr(i)+' : '+ floattostr(temps[i-1])+'    '+inttostr(i+8)+' : '+ floattostr(temps[i+7]));
end;

end.
